/***************************************************************
 * Name:      TestPlotMain.cpp
 * Purpose:   Code for Application Frame
 * Author:     ()
 * Created:   2010-02-05
 * Copyright:  ()
 * License:
 **************************************************************/

#include "TestPlotMain.h"
#include <wx/msgdlg.h>

//(*InternalHeaders(TestPlotFrame)
#include <wx/string.h>
#include <wx/intl.h>
#include <wx/font.h>
//*)

//helper functions
enum wxbuildinfoformat {
    short_f, long_f };

wxString wxbuildinfo(wxbuildinfoformat format)
{
    wxString wxbuild(wxVERSION_STRING);

    if (format == long_f )
    {
#if defined(__WXMSW__)
        wxbuild << _T("-Windows");
#elif defined(__UNIX__)
        wxbuild << _T("-Linux");
#endif

#if wxUSE_UNICODE
        wxbuild << _T("-Unicode build");
#else
        wxbuild << _T("-ANSI build");
#endif // wxUSE_UNICODE
    }

    return wxbuild;
}

//(*IdInit(TestPlotFrame)
const long TestPlotFrame::ID_AXIS1 = wxNewId();
const long TestPlotFrame::ID_AXIS2 = wxNewId();
const long TestPlotFrame::ID_MARKER1 = wxNewId();
const long TestPlotFrame::ID_VECTOR1 = wxNewId();
const long TestPlotFrame::ID_VECTOR2 = wxNewId();
const long TestPlotFrame::ID_VECTOR3 = wxNewId();
const long TestPlotFrame::ID_VECTOR4 = wxNewId();
const long TestPlotFrame::ID_MATHPLOT1 = wxNewId();
const long TestPlotFrame::ID_PANEL1 = wxNewId();
const long TestPlotFrame::idMenuQuit = wxNewId();
const long TestPlotFrame::idMenuAbout = wxNewId();
//*)

BEGIN_EVENT_TABLE(TestPlotFrame,wxFrame)
    //(*EventTable(TestPlotFrame)
    //*)
END_EVENT_TABLE()

TestPlotFrame::TestPlotFrame(wxWindow* parent,wxWindowID id)
{
    //(*Initialize(TestPlotFrame)
    wxMenuItem* MenuItem2;
    wxMenuItem* MenuItem1;
    wxMenu* Menu1;
    wxMenuBar* MenuBar1;
    wxMenu* Menu2;

    Create(parent, id, _("Test of MathPlot"), wxDefaultPosition, wxDefaultSize, wxDEFAULT_FRAME_STYLE, _T("id"));
    SetClientSize(wxSize(380,420));
    Panel1 = new wxPanel(this, ID_PANEL1, wxPoint(72,96), wxSize(360,400), wxTAB_TRAVERSAL, _T("ID_PANEL1"));
    MathPlot1 = new mpWindow(Panel1, ID_MATHPLOT1, wxPoint(8,8), wxSize(360,400), wxRAISED_BORDER|wxTAB_TRAVERSAL);
    MathPlot1->SetBackgroundColour(wxColour(0,0,0));
    Axis1 = new mpScaleX(_("Deg"), 4, true);
    wxPen   Axis1_PEN(wxColour(255,255,255));
    Axis1->SetPen(Axis1_PEN);
    wxFont Axis1_FONT(10,wxFONTFAMILY_SWISS,wxFONTSTYLE_NORMAL,wxFONTWEIGHT_NORMAL,false,_T("Arial"),wxFONTENCODING_DEFAULT);
    Axis1->SetFont(Axis1_FONT);
    MathPlot1->AddLayer(Axis1);
    Axis2 = new mpScaleY(_("Range"), 5, true);
    wxPen   Axis2_PEN(wxColour(255,255,255));
    Axis2->SetPen(Axis2_PEN);
    wxFont Axis2_FONT(10,wxFONTFAMILY_SWISS,wxFONTSTYLE_NORMAL,wxFONTWEIGHT_NORMAL,false,_T("Arial"),wxFONTENCODING_DEFAULT);
    Axis2->SetFont(Axis2_FONT);
    MathPlot1->AddLayer(Axis2);
    Marker1 = new mpMarker(_("Trig Curves"), 180, 1.5);
    wxPen   Marker1_PEN(wxColour(255,255,0));
    Marker1->SetPen(Marker1_PEN);
    wxFont Marker1_FONT(12,wxFONTFAMILY_SWISS,wxFONTSTYLE_NORMAL,wxFONTWEIGHT_BOLD,false,_T("Arial"),wxFONTENCODING_DEFAULT);
    Marker1->SetFont(Marker1_FONT);
    MathPlot1->AddLayer(Marker1);
    Vector1 = new mpFXYVector(_("Sin"), 0);
    wxPen   Vector1_PEN(wxColour(255,0,0));
    Vector1->SetPen(Vector1_PEN);
    Vector1_X.push_back(1);   Vector1_Y.push_back(0.02);
    Vector1_X.push_back(2);   Vector1_Y.push_back(0.03);
    Vector1_X.push_back(3);   Vector1_Y.push_back(0.05);
    Vector1_X.push_back(4);   Vector1_Y.push_back(0.07);
    Vector1_X.push_back(5);   Vector1_Y.push_back(0.09);
    Vector1_X.push_back(6);   Vector1_Y.push_back(0.1);
    Vector1_X.push_back(7);   Vector1_Y.push_back(0.12);
    Vector1_X.push_back(8);   Vector1_Y.push_back(0.14);
    Vector1_X.push_back(9);   Vector1_Y.push_back(0.16);
    Vector1_X.push_back(10);   Vector1_Y.push_back(0.17);
    Vector1_X.push_back(11);   Vector1_Y.push_back(0.19);
    Vector1_X.push_back(12);   Vector1_Y.push_back(0.21);
    Vector1_X.push_back(13);   Vector1_Y.push_back(0.22);
    Vector1_X.push_back(14);   Vector1_Y.push_back(0.24);
    Vector1_X.push_back(15);   Vector1_Y.push_back(0.26);
    Vector1_X.push_back(16);   Vector1_Y.push_back(0.28);
    Vector1_X.push_back(17);   Vector1_Y.push_back(0.29);
    Vector1_X.push_back(18);   Vector1_Y.push_back(0.31);
    Vector1_X.push_back(19);   Vector1_Y.push_back(0.33);
    Vector1_X.push_back(20);   Vector1_Y.push_back(0.34);
    Vector1_X.push_back(21);   Vector1_Y.push_back(0.36);
    Vector1_X.push_back(22);   Vector1_Y.push_back(0.37);
    Vector1_X.push_back(23);   Vector1_Y.push_back(0.39);
    Vector1_X.push_back(24);   Vector1_Y.push_back(0.41);
    Vector1_X.push_back(25);   Vector1_Y.push_back(0.42);
    Vector1_X.push_back(26);   Vector1_Y.push_back(0.44);
    Vector1_X.push_back(27);   Vector1_Y.push_back(0.45);
    Vector1_X.push_back(28);   Vector1_Y.push_back(0.47);
    Vector1_X.push_back(29);   Vector1_Y.push_back(0.48);
    Vector1_X.push_back(30);   Vector1_Y.push_back(0.5);
    Vector1_X.push_back(31);   Vector1_Y.push_back(0.52);
    Vector1_X.push_back(32);   Vector1_Y.push_back(0.53);
    Vector1_X.push_back(33);   Vector1_Y.push_back(0.54);
    Vector1_X.push_back(34);   Vector1_Y.push_back(0.56);
    Vector1_X.push_back(35);   Vector1_Y.push_back(0.57);
    Vector1_X.push_back(36);   Vector1_Y.push_back(0.59);
    Vector1_X.push_back(37);   Vector1_Y.push_back(0.6);
    Vector1_X.push_back(38);   Vector1_Y.push_back(0.62);
    Vector1_X.push_back(39);   Vector1_Y.push_back(0.63);
    Vector1_X.push_back(40);   Vector1_Y.push_back(0.64);
    Vector1_X.push_back(41);   Vector1_Y.push_back(0.66);
    Vector1_X.push_back(42);   Vector1_Y.push_back(0.67);
    Vector1_X.push_back(43);   Vector1_Y.push_back(0.68);
    Vector1_X.push_back(44);   Vector1_Y.push_back(0.69);
    Vector1_X.push_back(45);   Vector1_Y.push_back(0.71);
    Vector1_X.push_back(46);   Vector1_Y.push_back(0.72);
    Vector1_X.push_back(47);   Vector1_Y.push_back(0.73);
    Vector1_X.push_back(48);   Vector1_Y.push_back(0.74);
    Vector1_X.push_back(49);   Vector1_Y.push_back(0.75);
    Vector1_X.push_back(50);   Vector1_Y.push_back(0.77);
    Vector1_X.push_back(51);   Vector1_Y.push_back(0.78);
    Vector1_X.push_back(52);   Vector1_Y.push_back(0.79);
    Vector1_X.push_back(53);   Vector1_Y.push_back(0.8);
    Vector1_X.push_back(54);   Vector1_Y.push_back(0.81);
    Vector1_X.push_back(55);   Vector1_Y.push_back(0.82);
    Vector1_X.push_back(56);   Vector1_Y.push_back(0.83);
    Vector1_X.push_back(57);   Vector1_Y.push_back(0.84);
    Vector1_X.push_back(58);   Vector1_Y.push_back(0.85);
    Vector1_X.push_back(59);   Vector1_Y.push_back(0.86);
    Vector1_X.push_back(60);   Vector1_Y.push_back(0.87);
    Vector1_X.push_back(61);   Vector1_Y.push_back(0.87);
    Vector1_X.push_back(62);   Vector1_Y.push_back(0.88);
    Vector1_X.push_back(63);   Vector1_Y.push_back(0.89);
    Vector1_X.push_back(64);   Vector1_Y.push_back(0.9);
    Vector1_X.push_back(65);   Vector1_Y.push_back(0.91);
    Vector1_X.push_back(66);   Vector1_Y.push_back(0.91);
    Vector1_X.push_back(67);   Vector1_Y.push_back(0.92);
    Vector1_X.push_back(68);   Vector1_Y.push_back(0.93);
    Vector1_X.push_back(69);   Vector1_Y.push_back(0.93);
    Vector1_X.push_back(70);   Vector1_Y.push_back(0.94);
    Vector1_X.push_back(71);   Vector1_Y.push_back(0.95);
    Vector1_X.push_back(72);   Vector1_Y.push_back(0.95);
    Vector1_X.push_back(73);   Vector1_Y.push_back(0.96);
    Vector1_X.push_back(74);   Vector1_Y.push_back(0.96);
    Vector1_X.push_back(75);   Vector1_Y.push_back(0.97);
    Vector1_X.push_back(76);   Vector1_Y.push_back(0.97);
    Vector1_X.push_back(77);   Vector1_Y.push_back(0.97);
    Vector1_X.push_back(78);   Vector1_Y.push_back(0.98);
    Vector1_X.push_back(79);   Vector1_Y.push_back(0.98);
    Vector1_X.push_back(80);   Vector1_Y.push_back(0.98);
    Vector1_X.push_back(81);   Vector1_Y.push_back(0.99);
    Vector1_X.push_back(82);   Vector1_Y.push_back(0.99);
    Vector1_X.push_back(83);   Vector1_Y.push_back(0.99);
    Vector1_X.push_back(84);   Vector1_Y.push_back(0.99);
    Vector1_X.push_back(85);   Vector1_Y.push_back(1);
    Vector1_X.push_back(86);   Vector1_Y.push_back(1);
    Vector1_X.push_back(87);   Vector1_Y.push_back(1);
    Vector1_X.push_back(88);   Vector1_Y.push_back(1);
    Vector1_X.push_back(89);   Vector1_Y.push_back(1);
    Vector1_X.push_back(90);   Vector1_Y.push_back(1);
    Vector1_X.push_back(91);   Vector1_Y.push_back(1);
    Vector1_X.push_back(92);   Vector1_Y.push_back(1);
    Vector1_X.push_back(93);   Vector1_Y.push_back(1);
    Vector1_X.push_back(94);   Vector1_Y.push_back(1);
    Vector1_X.push_back(95);   Vector1_Y.push_back(1);
    Vector1_X.push_back(96);   Vector1_Y.push_back(0.99);
    Vector1_X.push_back(97);   Vector1_Y.push_back(0.99);
    Vector1_X.push_back(98);   Vector1_Y.push_back(0.99);
    Vector1_X.push_back(99);   Vector1_Y.push_back(0.99);
    Vector1_X.push_back(100);   Vector1_Y.push_back(0.98);
    Vector1_X.push_back(101);   Vector1_Y.push_back(0.98);
    Vector1_X.push_back(102);   Vector1_Y.push_back(0.98);
    Vector1_X.push_back(103);   Vector1_Y.push_back(0.97);
    Vector1_X.push_back(104);   Vector1_Y.push_back(0.97);
    Vector1_X.push_back(105);   Vector1_Y.push_back(0.97);
    Vector1_X.push_back(106);   Vector1_Y.push_back(0.96);
    Vector1_X.push_back(107);   Vector1_Y.push_back(0.96);
    Vector1_X.push_back(108);   Vector1_Y.push_back(0.95);
    Vector1_X.push_back(109);   Vector1_Y.push_back(0.95);
    Vector1_X.push_back(110);   Vector1_Y.push_back(0.94);
    Vector1_X.push_back(111);   Vector1_Y.push_back(0.93);
    Vector1_X.push_back(112);   Vector1_Y.push_back(0.93);
    Vector1_X.push_back(113);   Vector1_Y.push_back(0.92);
    Vector1_X.push_back(114);   Vector1_Y.push_back(0.91);
    Vector1_X.push_back(115);   Vector1_Y.push_back(0.91);
    Vector1_X.push_back(116);   Vector1_Y.push_back(0.9);
    Vector1_X.push_back(117);   Vector1_Y.push_back(0.89);
    Vector1_X.push_back(118);   Vector1_Y.push_back(0.88);
    Vector1_X.push_back(119);   Vector1_Y.push_back(0.87);
    Vector1_X.push_back(120);   Vector1_Y.push_back(0.87);
    Vector1_X.push_back(121);   Vector1_Y.push_back(0.86);
    Vector1_X.push_back(122);   Vector1_Y.push_back(0.85);
    Vector1_X.push_back(123);   Vector1_Y.push_back(0.84);
    Vector1_X.push_back(124);   Vector1_Y.push_back(0.83);
    Vector1_X.push_back(125);   Vector1_Y.push_back(0.82);
    Vector1_X.push_back(126);   Vector1_Y.push_back(0.81);
    Vector1_X.push_back(127);   Vector1_Y.push_back(0.8);
    Vector1_X.push_back(128);   Vector1_Y.push_back(0.79);
    Vector1_X.push_back(129);   Vector1_Y.push_back(0.78);
    Vector1_X.push_back(130);   Vector1_Y.push_back(0.77);
    Vector1_X.push_back(131);   Vector1_Y.push_back(0.75);
    Vector1_X.push_back(132);   Vector1_Y.push_back(0.74);
    Vector1_X.push_back(133);   Vector1_Y.push_back(0.73);
    Vector1_X.push_back(134);   Vector1_Y.push_back(0.72);
    Vector1_X.push_back(135);   Vector1_Y.push_back(0.71);
    Vector1_X.push_back(136);   Vector1_Y.push_back(0.69);
    Vector1_X.push_back(137);   Vector1_Y.push_back(0.68);
    Vector1_X.push_back(138);   Vector1_Y.push_back(0.67);
    Vector1_X.push_back(139);   Vector1_Y.push_back(0.66);
    Vector1_X.push_back(140);   Vector1_Y.push_back(0.64);
    Vector1_X.push_back(141);   Vector1_Y.push_back(0.63);
    Vector1_X.push_back(142);   Vector1_Y.push_back(0.62);
    Vector1_X.push_back(143);   Vector1_Y.push_back(0.6);
    Vector1_X.push_back(144);   Vector1_Y.push_back(0.59);
    Vector1_X.push_back(145);   Vector1_Y.push_back(0.57);
    Vector1_X.push_back(146);   Vector1_Y.push_back(0.56);
    Vector1_X.push_back(147);   Vector1_Y.push_back(0.54);
    Vector1_X.push_back(148);   Vector1_Y.push_back(0.53);
    Vector1_X.push_back(149);   Vector1_Y.push_back(0.52);
    Vector1_X.push_back(150);   Vector1_Y.push_back(0.5);
    Vector1_X.push_back(151);   Vector1_Y.push_back(0.48);
    Vector1_X.push_back(152);   Vector1_Y.push_back(0.47);
    Vector1_X.push_back(153);   Vector1_Y.push_back(0.45);
    Vector1_X.push_back(154);   Vector1_Y.push_back(0.44);
    Vector1_X.push_back(155);   Vector1_Y.push_back(0.42);
    Vector1_X.push_back(156);   Vector1_Y.push_back(0.41);
    Vector1_X.push_back(157);   Vector1_Y.push_back(0.39);
    Vector1_X.push_back(158);   Vector1_Y.push_back(0.37);
    Vector1_X.push_back(159);   Vector1_Y.push_back(0.36);
    Vector1_X.push_back(160);   Vector1_Y.push_back(0.34);
    Vector1_X.push_back(161);   Vector1_Y.push_back(0.33);
    Vector1_X.push_back(162);   Vector1_Y.push_back(0.31);
    Vector1_X.push_back(163);   Vector1_Y.push_back(0.29);
    Vector1_X.push_back(164);   Vector1_Y.push_back(0.28);
    Vector1_X.push_back(165);   Vector1_Y.push_back(0.26);
    Vector1_X.push_back(166);   Vector1_Y.push_back(0.24);
    Vector1_X.push_back(167);   Vector1_Y.push_back(0.22);
    Vector1_X.push_back(168);   Vector1_Y.push_back(0.21);
    Vector1_X.push_back(169);   Vector1_Y.push_back(0.19);
    Vector1_X.push_back(170);   Vector1_Y.push_back(0.17);
    Vector1_X.push_back(171);   Vector1_Y.push_back(0.16);
    Vector1_X.push_back(172);   Vector1_Y.push_back(0.14);
    Vector1_X.push_back(173);   Vector1_Y.push_back(0.12);
    Vector1_X.push_back(174);   Vector1_Y.push_back(0.1);
    Vector1_X.push_back(175);   Vector1_Y.push_back(0.09);
    Vector1_X.push_back(176);   Vector1_Y.push_back(0.07);
    Vector1_X.push_back(177);   Vector1_Y.push_back(0.05);
    Vector1_X.push_back(178);   Vector1_Y.push_back(0.03);
    Vector1_X.push_back(179);   Vector1_Y.push_back(0.02);
    Vector1_X.push_back(180);   Vector1_Y.push_back(0);
    Vector1_X.push_back(181);   Vector1_Y.push_back(-0.02);
    Vector1_X.push_back(182);   Vector1_Y.push_back(-0.03);
    Vector1_X.push_back(183);   Vector1_Y.push_back(-0.05);
    Vector1_X.push_back(184);   Vector1_Y.push_back(-0.07);
    Vector1_X.push_back(185);   Vector1_Y.push_back(-0.09);
    Vector1_X.push_back(186);   Vector1_Y.push_back(-0.1);
    Vector1_X.push_back(187);   Vector1_Y.push_back(-0.12);
    Vector1_X.push_back(188);   Vector1_Y.push_back(-0.14);
    Vector1_X.push_back(189);   Vector1_Y.push_back(-0.16);
    Vector1_X.push_back(190);   Vector1_Y.push_back(-0.17);
    Vector1_X.push_back(191);   Vector1_Y.push_back(-0.19);
    Vector1_X.push_back(192);   Vector1_Y.push_back(-0.21);
    Vector1_X.push_back(193);   Vector1_Y.push_back(-0.22);
    Vector1_X.push_back(194);   Vector1_Y.push_back(-0.24);
    Vector1_X.push_back(195);   Vector1_Y.push_back(-0.26);
    Vector1_X.push_back(196);   Vector1_Y.push_back(-0.28);
    Vector1_X.push_back(197);   Vector1_Y.push_back(-0.29);
    Vector1_X.push_back(198);   Vector1_Y.push_back(-0.31);
    Vector1_X.push_back(199);   Vector1_Y.push_back(-0.33);
    Vector1_X.push_back(200);   Vector1_Y.push_back(-0.34);
    Vector1_X.push_back(201);   Vector1_Y.push_back(-0.36);
    Vector1_X.push_back(202);   Vector1_Y.push_back(-0.37);
    Vector1_X.push_back(203);   Vector1_Y.push_back(-0.39);
    Vector1_X.push_back(204);   Vector1_Y.push_back(-0.41);
    Vector1_X.push_back(205);   Vector1_Y.push_back(-0.42);
    Vector1_X.push_back(206);   Vector1_Y.push_back(-0.44);
    Vector1_X.push_back(207);   Vector1_Y.push_back(-0.45);
    Vector1_X.push_back(208);   Vector1_Y.push_back(-0.47);
    Vector1_X.push_back(209);   Vector1_Y.push_back(-0.48);
    Vector1_X.push_back(210);   Vector1_Y.push_back(-0.5);
    Vector1_X.push_back(211);   Vector1_Y.push_back(-0.52);
    Vector1_X.push_back(212);   Vector1_Y.push_back(-0.53);
    Vector1_X.push_back(213);   Vector1_Y.push_back(-0.54);
    Vector1_X.push_back(214);   Vector1_Y.push_back(-0.56);
    Vector1_X.push_back(215);   Vector1_Y.push_back(-0.57);
    Vector1_X.push_back(216);   Vector1_Y.push_back(-0.59);
    Vector1_X.push_back(217);   Vector1_Y.push_back(-0.6);
    Vector1_X.push_back(218);   Vector1_Y.push_back(-0.62);
    Vector1_X.push_back(219);   Vector1_Y.push_back(-0.63);
    Vector1_X.push_back(220);   Vector1_Y.push_back(-0.64);
    Vector1_X.push_back(221);   Vector1_Y.push_back(-0.66);
    Vector1_X.push_back(222);   Vector1_Y.push_back(-0.67);
    Vector1_X.push_back(223);   Vector1_Y.push_back(-0.68);
    Vector1_X.push_back(224);   Vector1_Y.push_back(-0.69);
    Vector1_X.push_back(225);   Vector1_Y.push_back(-0.71);
    Vector1_X.push_back(226);   Vector1_Y.push_back(-0.72);
    Vector1_X.push_back(227);   Vector1_Y.push_back(-0.73);
    Vector1_X.push_back(228);   Vector1_Y.push_back(-0.74);
    Vector1_X.push_back(229);   Vector1_Y.push_back(-0.75);
    Vector1_X.push_back(230);   Vector1_Y.push_back(-0.77);
    Vector1_X.push_back(231);   Vector1_Y.push_back(-0.78);
    Vector1_X.push_back(232);   Vector1_Y.push_back(-0.79);
    Vector1_X.push_back(233);   Vector1_Y.push_back(-0.8);
    Vector1_X.push_back(234);   Vector1_Y.push_back(-0.81);
    Vector1_X.push_back(235);   Vector1_Y.push_back(-0.82);
    Vector1_X.push_back(236);   Vector1_Y.push_back(-0.83);
    Vector1_X.push_back(237);   Vector1_Y.push_back(-0.84);
    Vector1_X.push_back(238);   Vector1_Y.push_back(-0.85);
    Vector1_X.push_back(239);   Vector1_Y.push_back(-0.86);
    Vector1_X.push_back(240);   Vector1_Y.push_back(-0.87);
    Vector1_X.push_back(241);   Vector1_Y.push_back(-0.87);
    Vector1_X.push_back(242);   Vector1_Y.push_back(-0.88);
    Vector1_X.push_back(243);   Vector1_Y.push_back(-0.89);
    Vector1_X.push_back(244);   Vector1_Y.push_back(-0.9);
    Vector1_X.push_back(245);   Vector1_Y.push_back(-0.91);
    Vector1_X.push_back(246);   Vector1_Y.push_back(-0.91);
    Vector1_X.push_back(247);   Vector1_Y.push_back(-0.92);
    Vector1_X.push_back(248);   Vector1_Y.push_back(-0.93);
    Vector1_X.push_back(249);   Vector1_Y.push_back(-0.93);
    Vector1_X.push_back(250);   Vector1_Y.push_back(-0.94);
    Vector1_X.push_back(251);   Vector1_Y.push_back(-0.95);
    Vector1_X.push_back(252);   Vector1_Y.push_back(-0.95);
    Vector1_X.push_back(253);   Vector1_Y.push_back(-0.96);
    Vector1_X.push_back(254);   Vector1_Y.push_back(-0.96);
    Vector1_X.push_back(255);   Vector1_Y.push_back(-0.97);
    Vector1_X.push_back(256);   Vector1_Y.push_back(-0.97);
    Vector1_X.push_back(257);   Vector1_Y.push_back(-0.97);
    Vector1_X.push_back(258);   Vector1_Y.push_back(-0.98);
    Vector1_X.push_back(259);   Vector1_Y.push_back(-0.98);
    Vector1_X.push_back(260);   Vector1_Y.push_back(-0.98);
    Vector1_X.push_back(261);   Vector1_Y.push_back(-0.99);
    Vector1_X.push_back(262);   Vector1_Y.push_back(-0.99);
    Vector1_X.push_back(263);   Vector1_Y.push_back(-0.99);
    Vector1_X.push_back(264);   Vector1_Y.push_back(-0.99);
    Vector1_X.push_back(265);   Vector1_Y.push_back(-1);
    Vector1_X.push_back(266);   Vector1_Y.push_back(-1);
    Vector1_X.push_back(267);   Vector1_Y.push_back(-1);
    Vector1_X.push_back(268);   Vector1_Y.push_back(-1);
    Vector1_X.push_back(269);   Vector1_Y.push_back(-1);
    Vector1_X.push_back(270);   Vector1_Y.push_back(-1);
    Vector1_X.push_back(271);   Vector1_Y.push_back(-1);
    Vector1_X.push_back(272);   Vector1_Y.push_back(-1);
    Vector1_X.push_back(273);   Vector1_Y.push_back(-1);
    Vector1_X.push_back(274);   Vector1_Y.push_back(-1);
    Vector1_X.push_back(275);   Vector1_Y.push_back(-1);
    Vector1_X.push_back(276);   Vector1_Y.push_back(-0.99);
    Vector1_X.push_back(277);   Vector1_Y.push_back(-0.99);
    Vector1_X.push_back(278);   Vector1_Y.push_back(-0.99);
    Vector1_X.push_back(279);   Vector1_Y.push_back(-0.99);
    Vector1_X.push_back(280);   Vector1_Y.push_back(-0.98);
    Vector1_X.push_back(281);   Vector1_Y.push_back(-0.98);
    Vector1_X.push_back(282);   Vector1_Y.push_back(-0.98);
    Vector1_X.push_back(283);   Vector1_Y.push_back(-0.97);
    Vector1_X.push_back(284);   Vector1_Y.push_back(-0.97);
    Vector1_X.push_back(285);   Vector1_Y.push_back(-0.97);
    Vector1_X.push_back(286);   Vector1_Y.push_back(-0.96);
    Vector1_X.push_back(287);   Vector1_Y.push_back(-0.96);
    Vector1_X.push_back(288);   Vector1_Y.push_back(-0.95);
    Vector1_X.push_back(289);   Vector1_Y.push_back(-0.95);
    Vector1_X.push_back(290);   Vector1_Y.push_back(-0.94);
    Vector1_X.push_back(291);   Vector1_Y.push_back(-0.93);
    Vector1_X.push_back(292);   Vector1_Y.push_back(-0.93);
    Vector1_X.push_back(293);   Vector1_Y.push_back(-0.92);
    Vector1_X.push_back(294);   Vector1_Y.push_back(-0.91);
    Vector1_X.push_back(295);   Vector1_Y.push_back(-0.91);
    Vector1_X.push_back(296);   Vector1_Y.push_back(-0.9);
    Vector1_X.push_back(297);   Vector1_Y.push_back(-0.89);
    Vector1_X.push_back(298);   Vector1_Y.push_back(-0.88);
    Vector1_X.push_back(299);   Vector1_Y.push_back(-0.87);
    Vector1_X.push_back(300);   Vector1_Y.push_back(-0.87);
    Vector1_X.push_back(301);   Vector1_Y.push_back(-0.86);
    Vector1_X.push_back(302);   Vector1_Y.push_back(-0.85);
    Vector1_X.push_back(303);   Vector1_Y.push_back(-0.84);
    Vector1_X.push_back(304);   Vector1_Y.push_back(-0.83);
    Vector1_X.push_back(305);   Vector1_Y.push_back(-0.82);
    Vector1_X.push_back(306);   Vector1_Y.push_back(-0.81);
    Vector1_X.push_back(307);   Vector1_Y.push_back(-0.8);
    Vector1_X.push_back(308);   Vector1_Y.push_back(-0.79);
    Vector1_X.push_back(309);   Vector1_Y.push_back(-0.78);
    Vector1_X.push_back(310);   Vector1_Y.push_back(-0.77);
    Vector1_X.push_back(311);   Vector1_Y.push_back(-0.75);
    Vector1_X.push_back(312);   Vector1_Y.push_back(-0.74);
    Vector1_X.push_back(313);   Vector1_Y.push_back(-0.73);
    Vector1_X.push_back(314);   Vector1_Y.push_back(-0.72);
    Vector1_X.push_back(315);   Vector1_Y.push_back(-0.71);
    Vector1_X.push_back(316);   Vector1_Y.push_back(-0.69);
    Vector1_X.push_back(317);   Vector1_Y.push_back(-0.68);
    Vector1_X.push_back(318);   Vector1_Y.push_back(-0.67);
    Vector1_X.push_back(319);   Vector1_Y.push_back(-0.66);
    Vector1_X.push_back(320);   Vector1_Y.push_back(-0.64);
    Vector1_X.push_back(321);   Vector1_Y.push_back(-0.63);
    Vector1_X.push_back(322);   Vector1_Y.push_back(-0.62);
    Vector1_X.push_back(323);   Vector1_Y.push_back(-0.6);
    Vector1_X.push_back(324);   Vector1_Y.push_back(-0.59);
    Vector1_X.push_back(325);   Vector1_Y.push_back(-0.57);
    Vector1_X.push_back(326);   Vector1_Y.push_back(-0.56);
    Vector1_X.push_back(327);   Vector1_Y.push_back(-0.54);
    Vector1_X.push_back(328);   Vector1_Y.push_back(-0.53);
    Vector1_X.push_back(329);   Vector1_Y.push_back(-0.52);
    Vector1_X.push_back(330);   Vector1_Y.push_back(-0.5);
    Vector1_X.push_back(331);   Vector1_Y.push_back(-0.48);
    Vector1_X.push_back(332);   Vector1_Y.push_back(-0.47);
    Vector1_X.push_back(333);   Vector1_Y.push_back(-0.45);
    Vector1_X.push_back(334);   Vector1_Y.push_back(-0.44);
    Vector1_X.push_back(335);   Vector1_Y.push_back(-0.42);
    Vector1_X.push_back(336);   Vector1_Y.push_back(-0.41);
    Vector1_X.push_back(337);   Vector1_Y.push_back(-0.39);
    Vector1_X.push_back(338);   Vector1_Y.push_back(-0.37);
    Vector1_X.push_back(339);   Vector1_Y.push_back(-0.36);
    Vector1_X.push_back(340);   Vector1_Y.push_back(-0.34);
    Vector1_X.push_back(341);   Vector1_Y.push_back(-0.33);
    Vector1_X.push_back(342);   Vector1_Y.push_back(-0.31);
    Vector1_X.push_back(343);   Vector1_Y.push_back(-0.29);
    Vector1_X.push_back(344);   Vector1_Y.push_back(-0.28);
    Vector1_X.push_back(345);   Vector1_Y.push_back(-0.26);
    Vector1_X.push_back(346);   Vector1_Y.push_back(-0.24);
    Vector1_X.push_back(347);   Vector1_Y.push_back(-0.22);
    Vector1_X.push_back(348);   Vector1_Y.push_back(-0.21);
    Vector1_X.push_back(349);   Vector1_Y.push_back(-0.19);
    Vector1_X.push_back(350);   Vector1_Y.push_back(-0.17);
    Vector1_X.push_back(351);   Vector1_Y.push_back(-0.16);
    Vector1_X.push_back(352);   Vector1_Y.push_back(-0.14);
    Vector1_X.push_back(353);   Vector1_Y.push_back(-0.12);
    Vector1_X.push_back(354);   Vector1_Y.push_back(-0.1);
    Vector1_X.push_back(355);   Vector1_Y.push_back(-0.09);
    Vector1_X.push_back(356);   Vector1_Y.push_back(-0.07);
    Vector1_X.push_back(357);   Vector1_Y.push_back(-0.05);
    Vector1_X.push_back(358);   Vector1_Y.push_back(-0.03);
    Vector1_X.push_back(359);   Vector1_Y.push_back(-0.02);
    Vector1_X.push_back(360);   Vector1_Y.push_back(0);
    Vector1_X.push_back(360);   Vector1_Y.push_back(0);
    Vector1->SetData(Vector1_X, Vector1_Y);
    Vector1->SetContinuity(true);
    MathPlot1->AddLayer(Vector1);
    Vector2 = new mpFXYVector(_("Cos"), 1);
    wxPen   Vector2_PEN(wxColour(0,0,255));
    Vector2->SetPen(Vector2_PEN);
    Vector2_X.push_back(1);   Vector2_Y.push_back(1);
    Vector2_X.push_back(2);   Vector2_Y.push_back(1);
    Vector2_X.push_back(3);   Vector2_Y.push_back(1);
    Vector2_X.push_back(4);   Vector2_Y.push_back(1);
    Vector2_X.push_back(5);   Vector2_Y.push_back(1);
    Vector2_X.push_back(6);   Vector2_Y.push_back(0.99);
    Vector2_X.push_back(7);   Vector2_Y.push_back(0.99);
    Vector2_X.push_back(8);   Vector2_Y.push_back(0.99);
    Vector2_X.push_back(9);   Vector2_Y.push_back(0.99);
    Vector2_X.push_back(10);   Vector2_Y.push_back(0.98);
    Vector2_X.push_back(11);   Vector2_Y.push_back(0.98);
    Vector2_X.push_back(12);   Vector2_Y.push_back(0.98);
    Vector2_X.push_back(13);   Vector2_Y.push_back(0.97);
    Vector2_X.push_back(14);   Vector2_Y.push_back(0.97);
    Vector2_X.push_back(15);   Vector2_Y.push_back(0.97);
    Vector2_X.push_back(16);   Vector2_Y.push_back(0.96);
    Vector2_X.push_back(17);   Vector2_Y.push_back(0.96);
    Vector2_X.push_back(18);   Vector2_Y.push_back(0.95);
    Vector2_X.push_back(19);   Vector2_Y.push_back(0.95);
    Vector2_X.push_back(20);   Vector2_Y.push_back(0.94);
    Vector2_X.push_back(21);   Vector2_Y.push_back(0.93);
    Vector2_X.push_back(22);   Vector2_Y.push_back(0.93);
    Vector2_X.push_back(23);   Vector2_Y.push_back(0.92);
    Vector2_X.push_back(24);   Vector2_Y.push_back(0.91);
    Vector2_X.push_back(25);   Vector2_Y.push_back(0.91);
    Vector2_X.push_back(26);   Vector2_Y.push_back(0.9);
    Vector2_X.push_back(27);   Vector2_Y.push_back(0.89);
    Vector2_X.push_back(28);   Vector2_Y.push_back(0.88);
    Vector2_X.push_back(29);   Vector2_Y.push_back(0.87);
    Vector2_X.push_back(30);   Vector2_Y.push_back(0.87);
    Vector2_X.push_back(31);   Vector2_Y.push_back(0.86);
    Vector2_X.push_back(32);   Vector2_Y.push_back(0.85);
    Vector2_X.push_back(33);   Vector2_Y.push_back(0.84);
    Vector2_X.push_back(34);   Vector2_Y.push_back(0.83);
    Vector2_X.push_back(35);   Vector2_Y.push_back(0.82);
    Vector2_X.push_back(36);   Vector2_Y.push_back(0.81);
    Vector2_X.push_back(37);   Vector2_Y.push_back(0.8);
    Vector2_X.push_back(38);   Vector2_Y.push_back(0.79);
    Vector2_X.push_back(39);   Vector2_Y.push_back(0.78);
    Vector2_X.push_back(40);   Vector2_Y.push_back(0.77);
    Vector2_X.push_back(41);   Vector2_Y.push_back(0.75);
    Vector2_X.push_back(42);   Vector2_Y.push_back(0.74);
    Vector2_X.push_back(43);   Vector2_Y.push_back(0.73);
    Vector2_X.push_back(44);   Vector2_Y.push_back(0.72);
    Vector2_X.push_back(45);   Vector2_Y.push_back(0.71);
    Vector2_X.push_back(46);   Vector2_Y.push_back(0.69);
    Vector2_X.push_back(47);   Vector2_Y.push_back(0.68);
    Vector2_X.push_back(48);   Vector2_Y.push_back(0.67);
    Vector2_X.push_back(49);   Vector2_Y.push_back(0.66);
    Vector2_X.push_back(50);   Vector2_Y.push_back(0.64);
    Vector2_X.push_back(51);   Vector2_Y.push_back(0.63);
    Vector2_X.push_back(52);   Vector2_Y.push_back(0.62);
    Vector2_X.push_back(53);   Vector2_Y.push_back(0.6);
    Vector2_X.push_back(54);   Vector2_Y.push_back(0.59);
    Vector2_X.push_back(55);   Vector2_Y.push_back(0.57);
    Vector2_X.push_back(56);   Vector2_Y.push_back(0.56);
    Vector2_X.push_back(57);   Vector2_Y.push_back(0.54);
    Vector2_X.push_back(58);   Vector2_Y.push_back(0.53);
    Vector2_X.push_back(59);   Vector2_Y.push_back(0.52);
    Vector2_X.push_back(60);   Vector2_Y.push_back(0.5);
    Vector2_X.push_back(61);   Vector2_Y.push_back(0.48);
    Vector2_X.push_back(62);   Vector2_Y.push_back(0.47);
    Vector2_X.push_back(63);   Vector2_Y.push_back(0.45);
    Vector2_X.push_back(64);   Vector2_Y.push_back(0.44);
    Vector2_X.push_back(65);   Vector2_Y.push_back(0.42);
    Vector2_X.push_back(66);   Vector2_Y.push_back(0.41);
    Vector2_X.push_back(67);   Vector2_Y.push_back(0.39);
    Vector2_X.push_back(68);   Vector2_Y.push_back(0.37);
    Vector2_X.push_back(69);   Vector2_Y.push_back(0.36);
    Vector2_X.push_back(70);   Vector2_Y.push_back(0.34);
    Vector2_X.push_back(71);   Vector2_Y.push_back(0.33);
    Vector2_X.push_back(72);   Vector2_Y.push_back(0.31);
    Vector2_X.push_back(73);   Vector2_Y.push_back(0.29);
    Vector2_X.push_back(74);   Vector2_Y.push_back(0.28);
    Vector2_X.push_back(75);   Vector2_Y.push_back(0.26);
    Vector2_X.push_back(76);   Vector2_Y.push_back(0.24);
    Vector2_X.push_back(77);   Vector2_Y.push_back(0.22);
    Vector2_X.push_back(78);   Vector2_Y.push_back(0.21);
    Vector2_X.push_back(79);   Vector2_Y.push_back(0.19);
    Vector2_X.push_back(80);   Vector2_Y.push_back(0.17);
    Vector2_X.push_back(81);   Vector2_Y.push_back(0.16);
    Vector2_X.push_back(82);   Vector2_Y.push_back(0.14);
    Vector2_X.push_back(83);   Vector2_Y.push_back(0.12);
    Vector2_X.push_back(84);   Vector2_Y.push_back(0.1);
    Vector2_X.push_back(85);   Vector2_Y.push_back(0.09);
    Vector2_X.push_back(86);   Vector2_Y.push_back(0.07);
    Vector2_X.push_back(87);   Vector2_Y.push_back(0.05);
    Vector2_X.push_back(88);   Vector2_Y.push_back(0.03);
    Vector2_X.push_back(89);   Vector2_Y.push_back(0.02);
    Vector2_X.push_back(90);   Vector2_Y.push_back(0);
    Vector2_X.push_back(91);   Vector2_Y.push_back(-0.02);
    Vector2_X.push_back(92);   Vector2_Y.push_back(-0.03);
    Vector2_X.push_back(93);   Vector2_Y.push_back(-0.05);
    Vector2_X.push_back(94);   Vector2_Y.push_back(-0.07);
    Vector2_X.push_back(95);   Vector2_Y.push_back(-0.09);
    Vector2_X.push_back(96);   Vector2_Y.push_back(-0.1);
    Vector2_X.push_back(97);   Vector2_Y.push_back(-0.12);
    Vector2_X.push_back(98);   Vector2_Y.push_back(-0.14);
    Vector2_X.push_back(99);   Vector2_Y.push_back(-0.16);
    Vector2_X.push_back(100);   Vector2_Y.push_back(-0.17);
    Vector2_X.push_back(101);   Vector2_Y.push_back(-0.19);
    Vector2_X.push_back(102);   Vector2_Y.push_back(-0.21);
    Vector2_X.push_back(103);   Vector2_Y.push_back(-0.22);
    Vector2_X.push_back(104);   Vector2_Y.push_back(-0.24);
    Vector2_X.push_back(105);   Vector2_Y.push_back(-0.26);
    Vector2_X.push_back(106);   Vector2_Y.push_back(-0.28);
    Vector2_X.push_back(107);   Vector2_Y.push_back(-0.29);
    Vector2_X.push_back(108);   Vector2_Y.push_back(-0.31);
    Vector2_X.push_back(109);   Vector2_Y.push_back(-0.33);
    Vector2_X.push_back(110);   Vector2_Y.push_back(-0.34);
    Vector2_X.push_back(111);   Vector2_Y.push_back(-0.36);
    Vector2_X.push_back(112);   Vector2_Y.push_back(-0.37);
    Vector2_X.push_back(113);   Vector2_Y.push_back(-0.39);
    Vector2_X.push_back(114);   Vector2_Y.push_back(-0.41);
    Vector2_X.push_back(115);   Vector2_Y.push_back(-0.42);
    Vector2_X.push_back(116);   Vector2_Y.push_back(-0.44);
    Vector2_X.push_back(117);   Vector2_Y.push_back(-0.45);
    Vector2_X.push_back(118);   Vector2_Y.push_back(-0.47);
    Vector2_X.push_back(119);   Vector2_Y.push_back(-0.48);
    Vector2_X.push_back(120);   Vector2_Y.push_back(-0.5);
    Vector2_X.push_back(121);   Vector2_Y.push_back(-0.52);
    Vector2_X.push_back(122);   Vector2_Y.push_back(-0.53);
    Vector2_X.push_back(123);   Vector2_Y.push_back(-0.54);
    Vector2_X.push_back(124);   Vector2_Y.push_back(-0.56);
    Vector2_X.push_back(125);   Vector2_Y.push_back(-0.57);
    Vector2_X.push_back(126);   Vector2_Y.push_back(-0.59);
    Vector2_X.push_back(127);   Vector2_Y.push_back(-0.6);
    Vector2_X.push_back(128);   Vector2_Y.push_back(-0.62);
    Vector2_X.push_back(129);   Vector2_Y.push_back(-0.63);
    Vector2_X.push_back(130);   Vector2_Y.push_back(-0.64);
    Vector2_X.push_back(131);   Vector2_Y.push_back(-0.66);
    Vector2_X.push_back(132);   Vector2_Y.push_back(-0.67);
    Vector2_X.push_back(133);   Vector2_Y.push_back(-0.68);
    Vector2_X.push_back(134);   Vector2_Y.push_back(-0.69);
    Vector2_X.push_back(135);   Vector2_Y.push_back(-0.71);
    Vector2_X.push_back(136);   Vector2_Y.push_back(-0.72);
    Vector2_X.push_back(137);   Vector2_Y.push_back(-0.73);
    Vector2_X.push_back(138);   Vector2_Y.push_back(-0.74);
    Vector2_X.push_back(139);   Vector2_Y.push_back(-0.75);
    Vector2_X.push_back(140);   Vector2_Y.push_back(-0.77);
    Vector2_X.push_back(141);   Vector2_Y.push_back(-0.78);
    Vector2_X.push_back(142);   Vector2_Y.push_back(-0.79);
    Vector2_X.push_back(143);   Vector2_Y.push_back(-0.8);
    Vector2_X.push_back(144);   Vector2_Y.push_back(-0.81);
    Vector2_X.push_back(145);   Vector2_Y.push_back(-0.82);
    Vector2_X.push_back(146);   Vector2_Y.push_back(-0.83);
    Vector2_X.push_back(147);   Vector2_Y.push_back(-0.84);
    Vector2_X.push_back(148);   Vector2_Y.push_back(-0.85);
    Vector2_X.push_back(149);   Vector2_Y.push_back(-0.86);
    Vector2_X.push_back(150);   Vector2_Y.push_back(-0.87);
    Vector2_X.push_back(151);   Vector2_Y.push_back(-0.87);
    Vector2_X.push_back(152);   Vector2_Y.push_back(-0.88);
    Vector2_X.push_back(153);   Vector2_Y.push_back(-0.89);
    Vector2_X.push_back(154);   Vector2_Y.push_back(-0.9);
    Vector2_X.push_back(155);   Vector2_Y.push_back(-0.91);
    Vector2_X.push_back(156);   Vector2_Y.push_back(-0.91);
    Vector2_X.push_back(157);   Vector2_Y.push_back(-0.92);
    Vector2_X.push_back(158);   Vector2_Y.push_back(-0.93);
    Vector2_X.push_back(159);   Vector2_Y.push_back(-0.93);
    Vector2_X.push_back(160);   Vector2_Y.push_back(-0.94);
    Vector2_X.push_back(161);   Vector2_Y.push_back(-0.95);
    Vector2_X.push_back(162);   Vector2_Y.push_back(-0.95);
    Vector2_X.push_back(163);   Vector2_Y.push_back(-0.96);
    Vector2_X.push_back(164);   Vector2_Y.push_back(-0.96);
    Vector2_X.push_back(165);   Vector2_Y.push_back(-0.97);
    Vector2_X.push_back(166);   Vector2_Y.push_back(-0.97);
    Vector2_X.push_back(167);   Vector2_Y.push_back(-0.97);
    Vector2_X.push_back(168);   Vector2_Y.push_back(-0.98);
    Vector2_X.push_back(169);   Vector2_Y.push_back(-0.98);
    Vector2_X.push_back(170);   Vector2_Y.push_back(-0.98);
    Vector2_X.push_back(171);   Vector2_Y.push_back(-0.99);
    Vector2_X.push_back(172);   Vector2_Y.push_back(-0.99);
    Vector2_X.push_back(173);   Vector2_Y.push_back(-0.99);
    Vector2_X.push_back(174);   Vector2_Y.push_back(-0.99);
    Vector2_X.push_back(175);   Vector2_Y.push_back(-1);
    Vector2_X.push_back(176);   Vector2_Y.push_back(-1);
    Vector2_X.push_back(177);   Vector2_Y.push_back(-1);
    Vector2_X.push_back(178);   Vector2_Y.push_back(-1);
    Vector2_X.push_back(179);   Vector2_Y.push_back(-1);
    Vector2_X.push_back(180);   Vector2_Y.push_back(-1);
    Vector2_X.push_back(181);   Vector2_Y.push_back(-1);
    Vector2_X.push_back(182);   Vector2_Y.push_back(-1);
    Vector2_X.push_back(183);   Vector2_Y.push_back(-1);
    Vector2_X.push_back(184);   Vector2_Y.push_back(-1);
    Vector2_X.push_back(185);   Vector2_Y.push_back(-1);
    Vector2_X.push_back(186);   Vector2_Y.push_back(-0.99);
    Vector2_X.push_back(187);   Vector2_Y.push_back(-0.99);
    Vector2_X.push_back(188);   Vector2_Y.push_back(-0.99);
    Vector2_X.push_back(189);   Vector2_Y.push_back(-0.99);
    Vector2_X.push_back(190);   Vector2_Y.push_back(-0.98);
    Vector2_X.push_back(191);   Vector2_Y.push_back(-0.98);
    Vector2_X.push_back(192);   Vector2_Y.push_back(-0.98);
    Vector2_X.push_back(193);   Vector2_Y.push_back(-0.97);
    Vector2_X.push_back(194);   Vector2_Y.push_back(-0.97);
    Vector2_X.push_back(195);   Vector2_Y.push_back(-0.97);
    Vector2_X.push_back(196);   Vector2_Y.push_back(-0.96);
    Vector2_X.push_back(197);   Vector2_Y.push_back(-0.96);
    Vector2_X.push_back(198);   Vector2_Y.push_back(-0.95);
    Vector2_X.push_back(199);   Vector2_Y.push_back(-0.95);
    Vector2_X.push_back(200);   Vector2_Y.push_back(-0.94);
    Vector2_X.push_back(201);   Vector2_Y.push_back(-0.93);
    Vector2_X.push_back(202);   Vector2_Y.push_back(-0.93);
    Vector2_X.push_back(203);   Vector2_Y.push_back(-0.92);
    Vector2_X.push_back(204);   Vector2_Y.push_back(-0.91);
    Vector2_X.push_back(205);   Vector2_Y.push_back(-0.91);
    Vector2_X.push_back(206);   Vector2_Y.push_back(-0.9);
    Vector2_X.push_back(207);   Vector2_Y.push_back(-0.89);
    Vector2_X.push_back(208);   Vector2_Y.push_back(-0.88);
    Vector2_X.push_back(209);   Vector2_Y.push_back(-0.87);
    Vector2_X.push_back(210);   Vector2_Y.push_back(-0.87);
    Vector2_X.push_back(211);   Vector2_Y.push_back(-0.86);
    Vector2_X.push_back(212);   Vector2_Y.push_back(-0.85);
    Vector2_X.push_back(213);   Vector2_Y.push_back(-0.84);
    Vector2_X.push_back(214);   Vector2_Y.push_back(-0.83);
    Vector2_X.push_back(215);   Vector2_Y.push_back(-0.82);
    Vector2_X.push_back(216);   Vector2_Y.push_back(-0.81);
    Vector2_X.push_back(217);   Vector2_Y.push_back(-0.8);
    Vector2_X.push_back(218);   Vector2_Y.push_back(-0.79);
    Vector2_X.push_back(219);   Vector2_Y.push_back(-0.78);
    Vector2_X.push_back(220);   Vector2_Y.push_back(-0.77);
    Vector2_X.push_back(221);   Vector2_Y.push_back(-0.75);
    Vector2_X.push_back(222);   Vector2_Y.push_back(-0.74);
    Vector2_X.push_back(223);   Vector2_Y.push_back(-0.73);
    Vector2_X.push_back(224);   Vector2_Y.push_back(-0.72);
    Vector2_X.push_back(225);   Vector2_Y.push_back(-0.71);
    Vector2_X.push_back(226);   Vector2_Y.push_back(-0.69);
    Vector2_X.push_back(227);   Vector2_Y.push_back(-0.68);
    Vector2_X.push_back(228);   Vector2_Y.push_back(-0.67);
    Vector2_X.push_back(229);   Vector2_Y.push_back(-0.66);
    Vector2_X.push_back(230);   Vector2_Y.push_back(-0.64);
    Vector2_X.push_back(231);   Vector2_Y.push_back(-0.63);
    Vector2_X.push_back(232);   Vector2_Y.push_back(-0.62);
    Vector2_X.push_back(233);   Vector2_Y.push_back(-0.6);
    Vector2_X.push_back(234);   Vector2_Y.push_back(-0.59);
    Vector2_X.push_back(235);   Vector2_Y.push_back(-0.57);
    Vector2_X.push_back(236);   Vector2_Y.push_back(-0.56);
    Vector2_X.push_back(237);   Vector2_Y.push_back(-0.54);
    Vector2_X.push_back(238);   Vector2_Y.push_back(-0.53);
    Vector2_X.push_back(239);   Vector2_Y.push_back(-0.52);
    Vector2_X.push_back(240);   Vector2_Y.push_back(-0.5);
    Vector2_X.push_back(241);   Vector2_Y.push_back(-0.48);
    Vector2_X.push_back(242);   Vector2_Y.push_back(-0.47);
    Vector2_X.push_back(243);   Vector2_Y.push_back(-0.45);
    Vector2_X.push_back(244);   Vector2_Y.push_back(-0.44);
    Vector2_X.push_back(245);   Vector2_Y.push_back(-0.42);
    Vector2_X.push_back(246);   Vector2_Y.push_back(-0.41);
    Vector2_X.push_back(247);   Vector2_Y.push_back(-0.39);
    Vector2_X.push_back(248);   Vector2_Y.push_back(-0.37);
    Vector2_X.push_back(249);   Vector2_Y.push_back(-0.36);
    Vector2_X.push_back(250);   Vector2_Y.push_back(-0.34);
    Vector2_X.push_back(251);   Vector2_Y.push_back(-0.33);
    Vector2_X.push_back(252);   Vector2_Y.push_back(-0.31);
    Vector2_X.push_back(253);   Vector2_Y.push_back(-0.29);
    Vector2_X.push_back(254);   Vector2_Y.push_back(-0.28);
    Vector2_X.push_back(255);   Vector2_Y.push_back(-0.26);
    Vector2_X.push_back(256);   Vector2_Y.push_back(-0.24);
    Vector2_X.push_back(257);   Vector2_Y.push_back(-0.22);
    Vector2_X.push_back(258);   Vector2_Y.push_back(-0.21);
    Vector2_X.push_back(259);   Vector2_Y.push_back(-0.19);
    Vector2_X.push_back(260);   Vector2_Y.push_back(-0.17);
    Vector2_X.push_back(261);   Vector2_Y.push_back(-0.16);
    Vector2_X.push_back(262);   Vector2_Y.push_back(-0.14);
    Vector2_X.push_back(263);   Vector2_Y.push_back(-0.12);
    Vector2_X.push_back(264);   Vector2_Y.push_back(-0.1);
    Vector2_X.push_back(265);   Vector2_Y.push_back(-0.09);
    Vector2_X.push_back(266);   Vector2_Y.push_back(-0.07);
    Vector2_X.push_back(267);   Vector2_Y.push_back(-0.05);
    Vector2_X.push_back(268);   Vector2_Y.push_back(-0.03);
    Vector2_X.push_back(269);   Vector2_Y.push_back(-0.02);
    Vector2_X.push_back(270);   Vector2_Y.push_back(0);
    Vector2_X.push_back(271);   Vector2_Y.push_back(0.02);
    Vector2_X.push_back(272);   Vector2_Y.push_back(0.03);
    Vector2_X.push_back(273);   Vector2_Y.push_back(0.05);
    Vector2_X.push_back(274);   Vector2_Y.push_back(0.07);
    Vector2_X.push_back(275);   Vector2_Y.push_back(0.09);
    Vector2_X.push_back(276);   Vector2_Y.push_back(0.1);
    Vector2_X.push_back(277);   Vector2_Y.push_back(0.12);
    Vector2_X.push_back(278);   Vector2_Y.push_back(0.14);
    Vector2_X.push_back(279);   Vector2_Y.push_back(0.16);
    Vector2_X.push_back(280);   Vector2_Y.push_back(0.17);
    Vector2_X.push_back(281);   Vector2_Y.push_back(0.19);
    Vector2_X.push_back(282);   Vector2_Y.push_back(0.21);
    Vector2_X.push_back(283);   Vector2_Y.push_back(0.22);
    Vector2_X.push_back(284);   Vector2_Y.push_back(0.24);
    Vector2_X.push_back(285);   Vector2_Y.push_back(0.26);
    Vector2_X.push_back(286);   Vector2_Y.push_back(0.28);
    Vector2_X.push_back(287);   Vector2_Y.push_back(0.29);
    Vector2_X.push_back(288);   Vector2_Y.push_back(0.31);
    Vector2_X.push_back(289);   Vector2_Y.push_back(0.33);
    Vector2_X.push_back(290);   Vector2_Y.push_back(0.34);
    Vector2_X.push_back(291);   Vector2_Y.push_back(0.36);
    Vector2_X.push_back(292);   Vector2_Y.push_back(0.37);
    Vector2_X.push_back(293);   Vector2_Y.push_back(0.39);
    Vector2_X.push_back(294);   Vector2_Y.push_back(0.41);
    Vector2_X.push_back(295);   Vector2_Y.push_back(0.42);
    Vector2_X.push_back(296);   Vector2_Y.push_back(0.44);
    Vector2_X.push_back(297);   Vector2_Y.push_back(0.45);
    Vector2_X.push_back(298);   Vector2_Y.push_back(0.47);
    Vector2_X.push_back(299);   Vector2_Y.push_back(0.48);
    Vector2_X.push_back(300);   Vector2_Y.push_back(0.5);
    Vector2_X.push_back(301);   Vector2_Y.push_back(0.52);
    Vector2_X.push_back(302);   Vector2_Y.push_back(0.53);
    Vector2_X.push_back(303);   Vector2_Y.push_back(0.54);
    Vector2_X.push_back(304);   Vector2_Y.push_back(0.56);
    Vector2_X.push_back(305);   Vector2_Y.push_back(0.57);
    Vector2_X.push_back(306);   Vector2_Y.push_back(0.59);
    Vector2_X.push_back(307);   Vector2_Y.push_back(0.6);
    Vector2_X.push_back(308);   Vector2_Y.push_back(0.62);
    Vector2_X.push_back(309);   Vector2_Y.push_back(0.63);
    Vector2_X.push_back(310);   Vector2_Y.push_back(0.64);
    Vector2_X.push_back(311);   Vector2_Y.push_back(0.66);
    Vector2_X.push_back(312);   Vector2_Y.push_back(0.67);
    Vector2_X.push_back(313);   Vector2_Y.push_back(0.68);
    Vector2_X.push_back(314);   Vector2_Y.push_back(0.69);
    Vector2_X.push_back(315);   Vector2_Y.push_back(0.71);
    Vector2_X.push_back(316);   Vector2_Y.push_back(0.72);
    Vector2_X.push_back(317);   Vector2_Y.push_back(0.73);
    Vector2_X.push_back(318);   Vector2_Y.push_back(0.74);
    Vector2_X.push_back(319);   Vector2_Y.push_back(0.75);
    Vector2_X.push_back(320);   Vector2_Y.push_back(0.77);
    Vector2_X.push_back(321);   Vector2_Y.push_back(0.78);
    Vector2_X.push_back(322);   Vector2_Y.push_back(0.79);
    Vector2_X.push_back(323);   Vector2_Y.push_back(0.8);
    Vector2_X.push_back(324);   Vector2_Y.push_back(0.81);
    Vector2_X.push_back(325);   Vector2_Y.push_back(0.82);
    Vector2_X.push_back(326);   Vector2_Y.push_back(0.83);
    Vector2_X.push_back(327);   Vector2_Y.push_back(0.84);
    Vector2_X.push_back(328);   Vector2_Y.push_back(0.85);
    Vector2_X.push_back(329);   Vector2_Y.push_back(0.86);
    Vector2_X.push_back(330);   Vector2_Y.push_back(0.87);
    Vector2_X.push_back(331);   Vector2_Y.push_back(0.87);
    Vector2_X.push_back(332);   Vector2_Y.push_back(0.88);
    Vector2_X.push_back(333);   Vector2_Y.push_back(0.89);
    Vector2_X.push_back(334);   Vector2_Y.push_back(0.9);
    Vector2_X.push_back(335);   Vector2_Y.push_back(0.91);
    Vector2_X.push_back(336);   Vector2_Y.push_back(0.91);
    Vector2_X.push_back(337);   Vector2_Y.push_back(0.92);
    Vector2_X.push_back(338);   Vector2_Y.push_back(0.93);
    Vector2_X.push_back(339);   Vector2_Y.push_back(0.93);
    Vector2_X.push_back(340);   Vector2_Y.push_back(0.94);
    Vector2_X.push_back(341);   Vector2_Y.push_back(0.95);
    Vector2_X.push_back(342);   Vector2_Y.push_back(0.95);
    Vector2_X.push_back(343);   Vector2_Y.push_back(0.96);
    Vector2_X.push_back(344);   Vector2_Y.push_back(0.96);
    Vector2_X.push_back(345);   Vector2_Y.push_back(0.97);
    Vector2_X.push_back(346);   Vector2_Y.push_back(0.97);
    Vector2_X.push_back(347);   Vector2_Y.push_back(0.97);
    Vector2_X.push_back(348);   Vector2_Y.push_back(0.98);
    Vector2_X.push_back(349);   Vector2_Y.push_back(0.98);
    Vector2_X.push_back(350);   Vector2_Y.push_back(0.98);
    Vector2_X.push_back(351);   Vector2_Y.push_back(0.99);
    Vector2_X.push_back(352);   Vector2_Y.push_back(0.99);
    Vector2_X.push_back(353);   Vector2_Y.push_back(0.99);
    Vector2_X.push_back(354);   Vector2_Y.push_back(0.99);
    Vector2_X.push_back(355);   Vector2_Y.push_back(1);
    Vector2_X.push_back(356);   Vector2_Y.push_back(1);
    Vector2_X.push_back(357);   Vector2_Y.push_back(1);
    Vector2_X.push_back(358);   Vector2_Y.push_back(1);
    Vector2_X.push_back(359);   Vector2_Y.push_back(1);
    Vector2_X.push_back(360);   Vector2_Y.push_back(1);
    Vector2_X.push_back(360);   Vector2_Y.push_back(1);
    Vector2->SetData(Vector2_X, Vector2_Y);
    Vector2->SetContinuity(true);
    MathPlot1->AddLayer(Vector2);
    Vector3 = new mpFXYVector(_("Sin+Cos"), 3);
    wxPen   Vector3_PEN(wxColour(255,128,255));
    Vector3->SetPen(Vector3_PEN);
    Vector3_X.push_back(1);   Vector3_Y.push_back(1.02);
    Vector3_X.push_back(2);   Vector3_Y.push_back(1.03);
    Vector3_X.push_back(3);   Vector3_Y.push_back(1.05);
    Vector3_X.push_back(4);   Vector3_Y.push_back(1.07);
    Vector3_X.push_back(5);   Vector3_Y.push_back(1.08);
    Vector3_X.push_back(6);   Vector3_Y.push_back(1.1);
    Vector3_X.push_back(7);   Vector3_Y.push_back(1.11);
    Vector3_X.push_back(8);   Vector3_Y.push_back(1.13);
    Vector3_X.push_back(9);   Vector3_Y.push_back(1.14);
    Vector3_X.push_back(10);   Vector3_Y.push_back(1.16);
    Vector3_X.push_back(11);   Vector3_Y.push_back(1.17);
    Vector3_X.push_back(12);   Vector3_Y.push_back(1.19);
    Vector3_X.push_back(13);   Vector3_Y.push_back(1.2);
    Vector3_X.push_back(14);   Vector3_Y.push_back(1.21);
    Vector3_X.push_back(15);   Vector3_Y.push_back(1.22);
    Vector3_X.push_back(16);   Vector3_Y.push_back(1.24);
    Vector3_X.push_back(17);   Vector3_Y.push_back(1.25);
    Vector3_X.push_back(18);   Vector3_Y.push_back(1.26);
    Vector3_X.push_back(19);   Vector3_Y.push_back(1.27);
    Vector3_X.push_back(20);   Vector3_Y.push_back(1.28);
    Vector3_X.push_back(21);   Vector3_Y.push_back(1.29);
    Vector3_X.push_back(22);   Vector3_Y.push_back(1.3);
    Vector3_X.push_back(23);   Vector3_Y.push_back(1.31);
    Vector3_X.push_back(24);   Vector3_Y.push_back(1.32);
    Vector3_X.push_back(25);   Vector3_Y.push_back(1.33);
    Vector3_X.push_back(26);   Vector3_Y.push_back(1.34);
    Vector3_X.push_back(27);   Vector3_Y.push_back(1.34);
    Vector3_X.push_back(28);   Vector3_Y.push_back(1.35);
    Vector3_X.push_back(29);   Vector3_Y.push_back(1.36);
    Vector3_X.push_back(30);   Vector3_Y.push_back(1.37);
    Vector3_X.push_back(31);   Vector3_Y.push_back(1.37);
    Vector3_X.push_back(32);   Vector3_Y.push_back(1.38);
    Vector3_X.push_back(33);   Vector3_Y.push_back(1.38);
    Vector3_X.push_back(34);   Vector3_Y.push_back(1.39);
    Vector3_X.push_back(35);   Vector3_Y.push_back(1.39);
    Vector3_X.push_back(36);   Vector3_Y.push_back(1.4);
    Vector3_X.push_back(37);   Vector3_Y.push_back(1.4);
    Vector3_X.push_back(38);   Vector3_Y.push_back(1.4);
    Vector3_X.push_back(39);   Vector3_Y.push_back(1.41);
    Vector3_X.push_back(40);   Vector3_Y.push_back(1.41);
    Vector3_X.push_back(41);   Vector3_Y.push_back(1.41);
    Vector3_X.push_back(42);   Vector3_Y.push_back(1.41);
    Vector3_X.push_back(43);   Vector3_Y.push_back(1.41);
    Vector3_X.push_back(44);   Vector3_Y.push_back(1.41);
    Vector3_X.push_back(45);   Vector3_Y.push_back(1.41);
    Vector3_X.push_back(46);   Vector3_Y.push_back(1.41);
    Vector3_X.push_back(47);   Vector3_Y.push_back(1.41);
    Vector3_X.push_back(48);   Vector3_Y.push_back(1.41);
    Vector3_X.push_back(49);   Vector3_Y.push_back(1.41);
    Vector3_X.push_back(50);   Vector3_Y.push_back(1.41);
    Vector3_X.push_back(51);   Vector3_Y.push_back(1.41);
    Vector3_X.push_back(52);   Vector3_Y.push_back(1.4);
    Vector3_X.push_back(53);   Vector3_Y.push_back(1.4);
    Vector3_X.push_back(54);   Vector3_Y.push_back(1.4);
    Vector3_X.push_back(55);   Vector3_Y.push_back(1.39);
    Vector3_X.push_back(56);   Vector3_Y.push_back(1.39);
    Vector3_X.push_back(57);   Vector3_Y.push_back(1.38);
    Vector3_X.push_back(58);   Vector3_Y.push_back(1.38);
    Vector3_X.push_back(59);   Vector3_Y.push_back(1.37);
    Vector3_X.push_back(60);   Vector3_Y.push_back(1.37);
    Vector3_X.push_back(61);   Vector3_Y.push_back(1.36);
    Vector3_X.push_back(62);   Vector3_Y.push_back(1.35);
    Vector3_X.push_back(63);   Vector3_Y.push_back(1.34);
    Vector3_X.push_back(64);   Vector3_Y.push_back(1.34);
    Vector3_X.push_back(65);   Vector3_Y.push_back(1.33);
    Vector3_X.push_back(66);   Vector3_Y.push_back(1.32);
    Vector3_X.push_back(67);   Vector3_Y.push_back(1.31);
    Vector3_X.push_back(68);   Vector3_Y.push_back(1.3);
    Vector3_X.push_back(69);   Vector3_Y.push_back(1.29);
    Vector3_X.push_back(70);   Vector3_Y.push_back(1.28);
    Vector3_X.push_back(71);   Vector3_Y.push_back(1.27);
    Vector3_X.push_back(72);   Vector3_Y.push_back(1.26);
    Vector3_X.push_back(73);   Vector3_Y.push_back(1.25);
    Vector3_X.push_back(74);   Vector3_Y.push_back(1.24);
    Vector3_X.push_back(75);   Vector3_Y.push_back(1.22);
    Vector3_X.push_back(76);   Vector3_Y.push_back(1.21);
    Vector3_X.push_back(77);   Vector3_Y.push_back(1.2);
    Vector3_X.push_back(78);   Vector3_Y.push_back(1.19);
    Vector3_X.push_back(79);   Vector3_Y.push_back(1.17);
    Vector3_X.push_back(80);   Vector3_Y.push_back(1.16);
    Vector3_X.push_back(81);   Vector3_Y.push_back(1.14);
    Vector3_X.push_back(82);   Vector3_Y.push_back(1.13);
    Vector3_X.push_back(83);   Vector3_Y.push_back(1.11);
    Vector3_X.push_back(84);   Vector3_Y.push_back(1.1);
    Vector3_X.push_back(85);   Vector3_Y.push_back(1.08);
    Vector3_X.push_back(86);   Vector3_Y.push_back(1.07);
    Vector3_X.push_back(87);   Vector3_Y.push_back(1.05);
    Vector3_X.push_back(88);   Vector3_Y.push_back(1.03);
    Vector3_X.push_back(89);   Vector3_Y.push_back(1.02);
    Vector3_X.push_back(90);   Vector3_Y.push_back(1);
    Vector3_X.push_back(91);   Vector3_Y.push_back(0.98);
    Vector3_X.push_back(92);   Vector3_Y.push_back(0.96);
    Vector3_X.push_back(93);   Vector3_Y.push_back(0.95);
    Vector3_X.push_back(94);   Vector3_Y.push_back(0.93);
    Vector3_X.push_back(95);   Vector3_Y.push_back(0.91);
    Vector3_X.push_back(96);   Vector3_Y.push_back(0.89);
    Vector3_X.push_back(97);   Vector3_Y.push_back(0.87);
    Vector3_X.push_back(98);   Vector3_Y.push_back(0.85);
    Vector3_X.push_back(99);   Vector3_Y.push_back(0.83);
    Vector3_X.push_back(100);   Vector3_Y.push_back(0.81);
    Vector3_X.push_back(101);   Vector3_Y.push_back(0.79);
    Vector3_X.push_back(102);   Vector3_Y.push_back(0.77);
    Vector3_X.push_back(103);   Vector3_Y.push_back(0.75);
    Vector3_X.push_back(104);   Vector3_Y.push_back(0.73);
    Vector3_X.push_back(105);   Vector3_Y.push_back(0.71);
    Vector3_X.push_back(106);   Vector3_Y.push_back(0.69);
    Vector3_X.push_back(107);   Vector3_Y.push_back(0.66);
    Vector3_X.push_back(108);   Vector3_Y.push_back(0.64);
    Vector3_X.push_back(109);   Vector3_Y.push_back(0.62);
    Vector3_X.push_back(110);   Vector3_Y.push_back(0.6);
    Vector3_X.push_back(111);   Vector3_Y.push_back(0.58);
    Vector3_X.push_back(112);   Vector3_Y.push_back(0.55);
    Vector3_X.push_back(113);   Vector3_Y.push_back(0.53);
    Vector3_X.push_back(114);   Vector3_Y.push_back(0.51);
    Vector3_X.push_back(115);   Vector3_Y.push_back(0.48);
    Vector3_X.push_back(116);   Vector3_Y.push_back(0.46);
    Vector3_X.push_back(117);   Vector3_Y.push_back(0.44);
    Vector3_X.push_back(118);   Vector3_Y.push_back(0.41);
    Vector3_X.push_back(119);   Vector3_Y.push_back(0.39);
    Vector3_X.push_back(120);   Vector3_Y.push_back(0.37);
    Vector3_X.push_back(121);   Vector3_Y.push_back(0.34);
    Vector3_X.push_back(122);   Vector3_Y.push_back(0.32);
    Vector3_X.push_back(123);   Vector3_Y.push_back(0.29);
    Vector3_X.push_back(124);   Vector3_Y.push_back(0.27);
    Vector3_X.push_back(125);   Vector3_Y.push_back(0.25);
    Vector3_X.push_back(126);   Vector3_Y.push_back(0.22);
    Vector3_X.push_back(127);   Vector3_Y.push_back(0.2);
    Vector3_X.push_back(128);   Vector3_Y.push_back(0.17);
    Vector3_X.push_back(129);   Vector3_Y.push_back(0.15);
    Vector3_X.push_back(130);   Vector3_Y.push_back(0.12);
    Vector3_X.push_back(131);   Vector3_Y.push_back(0.1);
    Vector3_X.push_back(132);   Vector3_Y.push_back(0.07);
    Vector3_X.push_back(133);   Vector3_Y.push_back(0.05);
    Vector3_X.push_back(134);   Vector3_Y.push_back(0.02);
    Vector3_X.push_back(135);   Vector3_Y.push_back(0);
    Vector3_X.push_back(136);   Vector3_Y.push_back(-0.02);
    Vector3_X.push_back(137);   Vector3_Y.push_back(-0.05);
    Vector3_X.push_back(138);   Vector3_Y.push_back(-0.07);
    Vector3_X.push_back(139);   Vector3_Y.push_back(-0.1);
    Vector3_X.push_back(140);   Vector3_Y.push_back(-0.12);
    Vector3_X.push_back(141);   Vector3_Y.push_back(-0.15);
    Vector3_X.push_back(142);   Vector3_Y.push_back(-0.17);
    Vector3_X.push_back(143);   Vector3_Y.push_back(-0.2);
    Vector3_X.push_back(144);   Vector3_Y.push_back(-0.22);
    Vector3_X.push_back(145);   Vector3_Y.push_back(-0.25);
    Vector3_X.push_back(146);   Vector3_Y.push_back(-0.27);
    Vector3_X.push_back(147);   Vector3_Y.push_back(-0.29);
    Vector3_X.push_back(148);   Vector3_Y.push_back(-0.32);
    Vector3_X.push_back(149);   Vector3_Y.push_back(-0.34);
    Vector3_X.push_back(150);   Vector3_Y.push_back(-0.37);
    Vector3_X.push_back(151);   Vector3_Y.push_back(-0.39);
    Vector3_X.push_back(152);   Vector3_Y.push_back(-0.41);
    Vector3_X.push_back(153);   Vector3_Y.push_back(-0.44);
    Vector3_X.push_back(154);   Vector3_Y.push_back(-0.46);
    Vector3_X.push_back(155);   Vector3_Y.push_back(-0.48);
    Vector3_X.push_back(156);   Vector3_Y.push_back(-0.51);
    Vector3_X.push_back(157);   Vector3_Y.push_back(-0.53);
    Vector3_X.push_back(158);   Vector3_Y.push_back(-0.55);
    Vector3_X.push_back(159);   Vector3_Y.push_back(-0.58);
    Vector3_X.push_back(160);   Vector3_Y.push_back(-0.6);
    Vector3_X.push_back(161);   Vector3_Y.push_back(-0.62);
    Vector3_X.push_back(162);   Vector3_Y.push_back(-0.64);
    Vector3_X.push_back(163);   Vector3_Y.push_back(-0.66);
    Vector3_X.push_back(164);   Vector3_Y.push_back(-0.69);
    Vector3_X.push_back(165);   Vector3_Y.push_back(-0.71);
    Vector3_X.push_back(166);   Vector3_Y.push_back(-0.73);
    Vector3_X.push_back(167);   Vector3_Y.push_back(-0.75);
    Vector3_X.push_back(168);   Vector3_Y.push_back(-0.77);
    Vector3_X.push_back(169);   Vector3_Y.push_back(-0.79);
    Vector3_X.push_back(170);   Vector3_Y.push_back(-0.81);
    Vector3_X.push_back(171);   Vector3_Y.push_back(-0.83);
    Vector3_X.push_back(172);   Vector3_Y.push_back(-0.85);
    Vector3_X.push_back(173);   Vector3_Y.push_back(-0.87);
    Vector3_X.push_back(174);   Vector3_Y.push_back(-0.89);
    Vector3_X.push_back(175);   Vector3_Y.push_back(-0.91);
    Vector3_X.push_back(176);   Vector3_Y.push_back(-0.93);
    Vector3_X.push_back(177);   Vector3_Y.push_back(-0.95);
    Vector3_X.push_back(178);   Vector3_Y.push_back(-0.96);
    Vector3_X.push_back(179);   Vector3_Y.push_back(-0.98);
    Vector3_X.push_back(180);   Vector3_Y.push_back(-1);
    Vector3_X.push_back(181);   Vector3_Y.push_back(-1.02);
    Vector3_X.push_back(182);   Vector3_Y.push_back(-1.03);
    Vector3_X.push_back(183);   Vector3_Y.push_back(-1.05);
    Vector3_X.push_back(184);   Vector3_Y.push_back(-1.07);
    Vector3_X.push_back(185);   Vector3_Y.push_back(-1.08);
    Vector3_X.push_back(186);   Vector3_Y.push_back(-1.1);
    Vector3_X.push_back(187);   Vector3_Y.push_back(-1.11);
    Vector3_X.push_back(188);   Vector3_Y.push_back(-1.13);
    Vector3_X.push_back(189);   Vector3_Y.push_back(-1.14);
    Vector3_X.push_back(190);   Vector3_Y.push_back(-1.16);
    Vector3_X.push_back(191);   Vector3_Y.push_back(-1.17);
    Vector3_X.push_back(192);   Vector3_Y.push_back(-1.19);
    Vector3_X.push_back(193);   Vector3_Y.push_back(-1.2);
    Vector3_X.push_back(194);   Vector3_Y.push_back(-1.21);
    Vector3_X.push_back(195);   Vector3_Y.push_back(-1.22);
    Vector3_X.push_back(196);   Vector3_Y.push_back(-1.24);
    Vector3_X.push_back(197);   Vector3_Y.push_back(-1.25);
    Vector3_X.push_back(198);   Vector3_Y.push_back(-1.26);
    Vector3_X.push_back(199);   Vector3_Y.push_back(-1.27);
    Vector3_X.push_back(200);   Vector3_Y.push_back(-1.28);
    Vector3_X.push_back(201);   Vector3_Y.push_back(-1.29);
    Vector3_X.push_back(202);   Vector3_Y.push_back(-1.3);
    Vector3_X.push_back(203);   Vector3_Y.push_back(-1.31);
    Vector3_X.push_back(204);   Vector3_Y.push_back(-1.32);
    Vector3_X.push_back(205);   Vector3_Y.push_back(-1.33);
    Vector3_X.push_back(206);   Vector3_Y.push_back(-1.34);
    Vector3_X.push_back(207);   Vector3_Y.push_back(-1.34);
    Vector3_X.push_back(208);   Vector3_Y.push_back(-1.35);
    Vector3_X.push_back(209);   Vector3_Y.push_back(-1.36);
    Vector3_X.push_back(210);   Vector3_Y.push_back(-1.37);
    Vector3_X.push_back(211);   Vector3_Y.push_back(-1.37);
    Vector3_X.push_back(212);   Vector3_Y.push_back(-1.38);
    Vector3_X.push_back(213);   Vector3_Y.push_back(-1.38);
    Vector3_X.push_back(214);   Vector3_Y.push_back(-1.39);
    Vector3_X.push_back(215);   Vector3_Y.push_back(-1.39);
    Vector3_X.push_back(216);   Vector3_Y.push_back(-1.4);
    Vector3_X.push_back(217);   Vector3_Y.push_back(-1.4);
    Vector3_X.push_back(218);   Vector3_Y.push_back(-1.4);
    Vector3_X.push_back(219);   Vector3_Y.push_back(-1.41);
    Vector3_X.push_back(220);   Vector3_Y.push_back(-1.41);
    Vector3_X.push_back(221);   Vector3_Y.push_back(-1.41);
    Vector3_X.push_back(222);   Vector3_Y.push_back(-1.41);
    Vector3_X.push_back(223);   Vector3_Y.push_back(-1.41);
    Vector3_X.push_back(224);   Vector3_Y.push_back(-1.41);
    Vector3_X.push_back(225);   Vector3_Y.push_back(-1.41);
    Vector3_X.push_back(226);   Vector3_Y.push_back(-1.41);
    Vector3_X.push_back(227);   Vector3_Y.push_back(-1.41);
    Vector3_X.push_back(228);   Vector3_Y.push_back(-1.41);
    Vector3_X.push_back(229);   Vector3_Y.push_back(-1.41);
    Vector3_X.push_back(230);   Vector3_Y.push_back(-1.41);
    Vector3_X.push_back(231);   Vector3_Y.push_back(-1.41);
    Vector3_X.push_back(232);   Vector3_Y.push_back(-1.4);
    Vector3_X.push_back(233);   Vector3_Y.push_back(-1.4);
    Vector3_X.push_back(234);   Vector3_Y.push_back(-1.4);
    Vector3_X.push_back(235);   Vector3_Y.push_back(-1.39);
    Vector3_X.push_back(236);   Vector3_Y.push_back(-1.39);
    Vector3_X.push_back(237);   Vector3_Y.push_back(-1.38);
    Vector3_X.push_back(238);   Vector3_Y.push_back(-1.38);
    Vector3_X.push_back(239);   Vector3_Y.push_back(-1.37);
    Vector3_X.push_back(240);   Vector3_Y.push_back(-1.37);
    Vector3_X.push_back(241);   Vector3_Y.push_back(-1.36);
    Vector3_X.push_back(242);   Vector3_Y.push_back(-1.35);
    Vector3_X.push_back(243);   Vector3_Y.push_back(-1.34);
    Vector3_X.push_back(244);   Vector3_Y.push_back(-1.34);
    Vector3_X.push_back(245);   Vector3_Y.push_back(-1.33);
    Vector3_X.push_back(246);   Vector3_Y.push_back(-1.32);
    Vector3_X.push_back(247);   Vector3_Y.push_back(-1.31);
    Vector3_X.push_back(248);   Vector3_Y.push_back(-1.3);
    Vector3_X.push_back(249);   Vector3_Y.push_back(-1.29);
    Vector3_X.push_back(250);   Vector3_Y.push_back(-1.28);
    Vector3_X.push_back(251);   Vector3_Y.push_back(-1.27);
    Vector3_X.push_back(252);   Vector3_Y.push_back(-1.26);
    Vector3_X.push_back(253);   Vector3_Y.push_back(-1.25);
    Vector3_X.push_back(254);   Vector3_Y.push_back(-1.24);
    Vector3_X.push_back(255);   Vector3_Y.push_back(-1.22);
    Vector3_X.push_back(256);   Vector3_Y.push_back(-1.21);
    Vector3_X.push_back(257);   Vector3_Y.push_back(-1.2);
    Vector3_X.push_back(258);   Vector3_Y.push_back(-1.19);
    Vector3_X.push_back(259);   Vector3_Y.push_back(-1.17);
    Vector3_X.push_back(260);   Vector3_Y.push_back(-1.16);
    Vector3_X.push_back(261);   Vector3_Y.push_back(-1.14);
    Vector3_X.push_back(262);   Vector3_Y.push_back(-1.13);
    Vector3_X.push_back(263);   Vector3_Y.push_back(-1.11);
    Vector3_X.push_back(264);   Vector3_Y.push_back(-1.1);
    Vector3_X.push_back(265);   Vector3_Y.push_back(-1.08);
    Vector3_X.push_back(266);   Vector3_Y.push_back(-1.07);
    Vector3_X.push_back(267);   Vector3_Y.push_back(-1.05);
    Vector3_X.push_back(268);   Vector3_Y.push_back(-1.03);
    Vector3_X.push_back(269);   Vector3_Y.push_back(-1.02);
    Vector3_X.push_back(270);   Vector3_Y.push_back(-1);
    Vector3_X.push_back(271);   Vector3_Y.push_back(-0.98);
    Vector3_X.push_back(272);   Vector3_Y.push_back(-0.96);
    Vector3_X.push_back(273);   Vector3_Y.push_back(-0.95);
    Vector3_X.push_back(274);   Vector3_Y.push_back(-0.93);
    Vector3_X.push_back(275);   Vector3_Y.push_back(-0.91);
    Vector3_X.push_back(276);   Vector3_Y.push_back(-0.89);
    Vector3_X.push_back(277);   Vector3_Y.push_back(-0.87);
    Vector3_X.push_back(278);   Vector3_Y.push_back(-0.85);
    Vector3_X.push_back(279);   Vector3_Y.push_back(-0.83);
    Vector3_X.push_back(280);   Vector3_Y.push_back(-0.81);
    Vector3_X.push_back(281);   Vector3_Y.push_back(-0.79);
    Vector3_X.push_back(282);   Vector3_Y.push_back(-0.77);
    Vector3_X.push_back(283);   Vector3_Y.push_back(-0.75);
    Vector3_X.push_back(284);   Vector3_Y.push_back(-0.73);
    Vector3_X.push_back(285);   Vector3_Y.push_back(-0.71);
    Vector3_X.push_back(286);   Vector3_Y.push_back(-0.69);
    Vector3_X.push_back(287);   Vector3_Y.push_back(-0.66);
    Vector3_X.push_back(288);   Vector3_Y.push_back(-0.64);
    Vector3_X.push_back(289);   Vector3_Y.push_back(-0.62);
    Vector3_X.push_back(290);   Vector3_Y.push_back(-0.6);
    Vector3_X.push_back(291);   Vector3_Y.push_back(-0.58);
    Vector3_X.push_back(292);   Vector3_Y.push_back(-0.55);
    Vector3_X.push_back(293);   Vector3_Y.push_back(-0.53);
    Vector3_X.push_back(294);   Vector3_Y.push_back(-0.51);
    Vector3_X.push_back(295);   Vector3_Y.push_back(-0.48);
    Vector3_X.push_back(296);   Vector3_Y.push_back(-0.46);
    Vector3_X.push_back(297);   Vector3_Y.push_back(-0.44);
    Vector3_X.push_back(298);   Vector3_Y.push_back(-0.41);
    Vector3_X.push_back(299);   Vector3_Y.push_back(-0.39);
    Vector3_X.push_back(300);   Vector3_Y.push_back(-0.37);
    Vector3_X.push_back(301);   Vector3_Y.push_back(-0.34);
    Vector3_X.push_back(302);   Vector3_Y.push_back(-0.32);
    Vector3_X.push_back(303);   Vector3_Y.push_back(-0.29);
    Vector3_X.push_back(304);   Vector3_Y.push_back(-0.27);
    Vector3_X.push_back(305);   Vector3_Y.push_back(-0.25);
    Vector3_X.push_back(306);   Vector3_Y.push_back(-0.22);
    Vector3_X.push_back(307);   Vector3_Y.push_back(-0.2);
    Vector3_X.push_back(308);   Vector3_Y.push_back(-0.17);
    Vector3_X.push_back(309);   Vector3_Y.push_back(-0.15);
    Vector3_X.push_back(310);   Vector3_Y.push_back(-0.12);
    Vector3_X.push_back(311);   Vector3_Y.push_back(-0.1);
    Vector3_X.push_back(312);   Vector3_Y.push_back(-0.07);
    Vector3_X.push_back(313);   Vector3_Y.push_back(-0.05);
    Vector3_X.push_back(314);   Vector3_Y.push_back(-0.02);
    Vector3_X.push_back(315);   Vector3_Y.push_back(0);
    Vector3_X.push_back(316);   Vector3_Y.push_back(0.02);
    Vector3_X.push_back(317);   Vector3_Y.push_back(0.05);
    Vector3_X.push_back(318);   Vector3_Y.push_back(0.07);
    Vector3_X.push_back(319);   Vector3_Y.push_back(0.1);
    Vector3_X.push_back(320);   Vector3_Y.push_back(0.12);
    Vector3_X.push_back(321);   Vector3_Y.push_back(0.15);
    Vector3_X.push_back(322);   Vector3_Y.push_back(0.17);
    Vector3_X.push_back(323);   Vector3_Y.push_back(0.2);
    Vector3_X.push_back(324);   Vector3_Y.push_back(0.22);
    Vector3_X.push_back(325);   Vector3_Y.push_back(0.25);
    Vector3_X.push_back(326);   Vector3_Y.push_back(0.27);
    Vector3_X.push_back(327);   Vector3_Y.push_back(0.29);
    Vector3_X.push_back(328);   Vector3_Y.push_back(0.32);
    Vector3_X.push_back(329);   Vector3_Y.push_back(0.34);
    Vector3_X.push_back(330);   Vector3_Y.push_back(0.37);
    Vector3_X.push_back(331);   Vector3_Y.push_back(0.39);
    Vector3_X.push_back(332);   Vector3_Y.push_back(0.41);
    Vector3_X.push_back(333);   Vector3_Y.push_back(0.44);
    Vector3_X.push_back(334);   Vector3_Y.push_back(0.46);
    Vector3_X.push_back(335);   Vector3_Y.push_back(0.48);
    Vector3_X.push_back(336);   Vector3_Y.push_back(0.51);
    Vector3_X.push_back(337);   Vector3_Y.push_back(0.53);
    Vector3_X.push_back(338);   Vector3_Y.push_back(0.55);
    Vector3_X.push_back(339);   Vector3_Y.push_back(0.58);
    Vector3_X.push_back(340);   Vector3_Y.push_back(0.6);
    Vector3_X.push_back(341);   Vector3_Y.push_back(0.62);
    Vector3_X.push_back(342);   Vector3_Y.push_back(0.64);
    Vector3_X.push_back(343);   Vector3_Y.push_back(0.66);
    Vector3_X.push_back(344);   Vector3_Y.push_back(0.69);
    Vector3_X.push_back(345);   Vector3_Y.push_back(0.71);
    Vector3_X.push_back(346);   Vector3_Y.push_back(0.73);
    Vector3_X.push_back(347);   Vector3_Y.push_back(0.75);
    Vector3_X.push_back(348);   Vector3_Y.push_back(0.77);
    Vector3_X.push_back(349);   Vector3_Y.push_back(0.79);
    Vector3_X.push_back(350);   Vector3_Y.push_back(0.81);
    Vector3_X.push_back(351);   Vector3_Y.push_back(0.83);
    Vector3_X.push_back(352);   Vector3_Y.push_back(0.85);
    Vector3_X.push_back(353);   Vector3_Y.push_back(0.87);
    Vector3_X.push_back(354);   Vector3_Y.push_back(0.89);
    Vector3_X.push_back(355);   Vector3_Y.push_back(0.91);
    Vector3_X.push_back(356);   Vector3_Y.push_back(0.93);
    Vector3_X.push_back(357);   Vector3_Y.push_back(0.95);
    Vector3_X.push_back(358);   Vector3_Y.push_back(0.96);
    Vector3_X.push_back(359);   Vector3_Y.push_back(0.98);
    Vector3_X.push_back(360);   Vector3_Y.push_back(1);
    Vector3_X.push_back(360);   Vector3_Y.push_back(1);
    Vector3->SetData(Vector3_X, Vector3_Y);
    Vector3->SetContinuity(true);
    MathPlot1->AddLayer(Vector3);
    Vector4 = new mpFXYVector(_("Sin-Cos"), 2);
    wxPen   Vector4_PEN(wxColour(0,255,0));
    Vector4->SetPen(Vector4_PEN);
    Vector4_X.push_back(1);   Vector4_Y.push_back(-0.98);
    Vector4_X.push_back(2);   Vector4_Y.push_back(-0.96);
    Vector4_X.push_back(3);   Vector4_Y.push_back(-0.95);
    Vector4_X.push_back(4);   Vector4_Y.push_back(-0.93);
    Vector4_X.push_back(5);   Vector4_Y.push_back(-0.91);
    Vector4_X.push_back(6);   Vector4_Y.push_back(-0.89);
    Vector4_X.push_back(7);   Vector4_Y.push_back(-0.87);
    Vector4_X.push_back(8);   Vector4_Y.push_back(-0.85);
    Vector4_X.push_back(9);   Vector4_Y.push_back(-0.83);
    Vector4_X.push_back(10);   Vector4_Y.push_back(-0.81);
    Vector4_X.push_back(11);   Vector4_Y.push_back(-0.79);
    Vector4_X.push_back(12);   Vector4_Y.push_back(-0.77);
    Vector4_X.push_back(13);   Vector4_Y.push_back(-0.75);
    Vector4_X.push_back(14);   Vector4_Y.push_back(-0.73);
    Vector4_X.push_back(15);   Vector4_Y.push_back(-0.71);
    Vector4_X.push_back(16);   Vector4_Y.push_back(-0.69);
    Vector4_X.push_back(17);   Vector4_Y.push_back(-0.66);
    Vector4_X.push_back(18);   Vector4_Y.push_back(-0.64);
    Vector4_X.push_back(19);   Vector4_Y.push_back(-0.62);
    Vector4_X.push_back(20);   Vector4_Y.push_back(-0.6);
    Vector4_X.push_back(21);   Vector4_Y.push_back(-0.58);
    Vector4_X.push_back(22);   Vector4_Y.push_back(-0.55);
    Vector4_X.push_back(23);   Vector4_Y.push_back(-0.53);
    Vector4_X.push_back(24);   Vector4_Y.push_back(-0.51);
    Vector4_X.push_back(25);   Vector4_Y.push_back(-0.48);
    Vector4_X.push_back(26);   Vector4_Y.push_back(-0.46);
    Vector4_X.push_back(27);   Vector4_Y.push_back(-0.44);
    Vector4_X.push_back(28);   Vector4_Y.push_back(-0.41);
    Vector4_X.push_back(29);   Vector4_Y.push_back(-0.39);
    Vector4_X.push_back(30);   Vector4_Y.push_back(-0.37);
    Vector4_X.push_back(31);   Vector4_Y.push_back(-0.34);
    Vector4_X.push_back(32);   Vector4_Y.push_back(-0.32);
    Vector4_X.push_back(33);   Vector4_Y.push_back(-0.29);
    Vector4_X.push_back(34);   Vector4_Y.push_back(-0.27);
    Vector4_X.push_back(35);   Vector4_Y.push_back(-0.25);
    Vector4_X.push_back(36);   Vector4_Y.push_back(-0.22);
    Vector4_X.push_back(37);   Vector4_Y.push_back(-0.2);
    Vector4_X.push_back(38);   Vector4_Y.push_back(-0.17);
    Vector4_X.push_back(39);   Vector4_Y.push_back(-0.15);
    Vector4_X.push_back(40);   Vector4_Y.push_back(-0.12);
    Vector4_X.push_back(41);   Vector4_Y.push_back(-0.1);
    Vector4_X.push_back(42);   Vector4_Y.push_back(-0.07);
    Vector4_X.push_back(43);   Vector4_Y.push_back(-0.05);
    Vector4_X.push_back(44);   Vector4_Y.push_back(-0.02);
    Vector4_X.push_back(45);   Vector4_Y.push_back(0);
    Vector4_X.push_back(46);   Vector4_Y.push_back(0.02);
    Vector4_X.push_back(47);   Vector4_Y.push_back(0.05);
    Vector4_X.push_back(48);   Vector4_Y.push_back(0.07);
    Vector4_X.push_back(49);   Vector4_Y.push_back(0.1);
    Vector4_X.push_back(50);   Vector4_Y.push_back(0.12);
    Vector4_X.push_back(51);   Vector4_Y.push_back(0.15);
    Vector4_X.push_back(52);   Vector4_Y.push_back(0.17);
    Vector4_X.push_back(53);   Vector4_Y.push_back(0.2);
    Vector4_X.push_back(54);   Vector4_Y.push_back(0.22);
    Vector4_X.push_back(55);   Vector4_Y.push_back(0.25);
    Vector4_X.push_back(56);   Vector4_Y.push_back(0.27);
    Vector4_X.push_back(57);   Vector4_Y.push_back(0.29);
    Vector4_X.push_back(58);   Vector4_Y.push_back(0.32);
    Vector4_X.push_back(59);   Vector4_Y.push_back(0.34);
    Vector4_X.push_back(60);   Vector4_Y.push_back(0.37);
    Vector4_X.push_back(61);   Vector4_Y.push_back(0.39);
    Vector4_X.push_back(62);   Vector4_Y.push_back(0.41);
    Vector4_X.push_back(63);   Vector4_Y.push_back(0.44);
    Vector4_X.push_back(64);   Vector4_Y.push_back(0.46);
    Vector4_X.push_back(65);   Vector4_Y.push_back(0.48);
    Vector4_X.push_back(66);   Vector4_Y.push_back(0.51);
    Vector4_X.push_back(67);   Vector4_Y.push_back(0.53);
    Vector4_X.push_back(68);   Vector4_Y.push_back(0.55);
    Vector4_X.push_back(69);   Vector4_Y.push_back(0.58);
    Vector4_X.push_back(70);   Vector4_Y.push_back(0.6);
    Vector4_X.push_back(71);   Vector4_Y.push_back(0.62);
    Vector4_X.push_back(72);   Vector4_Y.push_back(0.64);
    Vector4_X.push_back(73);   Vector4_Y.push_back(0.66);
    Vector4_X.push_back(74);   Vector4_Y.push_back(0.69);
    Vector4_X.push_back(75);   Vector4_Y.push_back(0.71);
    Vector4_X.push_back(76);   Vector4_Y.push_back(0.73);
    Vector4_X.push_back(77);   Vector4_Y.push_back(0.75);
    Vector4_X.push_back(78);   Vector4_Y.push_back(0.77);
    Vector4_X.push_back(79);   Vector4_Y.push_back(0.79);
    Vector4_X.push_back(80);   Vector4_Y.push_back(0.81);
    Vector4_X.push_back(81);   Vector4_Y.push_back(0.83);
    Vector4_X.push_back(82);   Vector4_Y.push_back(0.85);
    Vector4_X.push_back(83);   Vector4_Y.push_back(0.87);
    Vector4_X.push_back(84);   Vector4_Y.push_back(0.89);
    Vector4_X.push_back(85);   Vector4_Y.push_back(0.91);
    Vector4_X.push_back(86);   Vector4_Y.push_back(0.93);
    Vector4_X.push_back(87);   Vector4_Y.push_back(0.95);
    Vector4_X.push_back(88);   Vector4_Y.push_back(0.96);
    Vector4_X.push_back(89);   Vector4_Y.push_back(0.98);
    Vector4_X.push_back(90);   Vector4_Y.push_back(1);
    Vector4_X.push_back(91);   Vector4_Y.push_back(1.02);
    Vector4_X.push_back(92);   Vector4_Y.push_back(1.03);
    Vector4_X.push_back(93);   Vector4_Y.push_back(1.05);
    Vector4_X.push_back(94);   Vector4_Y.push_back(1.07);
    Vector4_X.push_back(95);   Vector4_Y.push_back(1.08);
    Vector4_X.push_back(96);   Vector4_Y.push_back(1.1);
    Vector4_X.push_back(97);   Vector4_Y.push_back(1.11);
    Vector4_X.push_back(98);   Vector4_Y.push_back(1.13);
    Vector4_X.push_back(99);   Vector4_Y.push_back(1.14);
    Vector4_X.push_back(100);   Vector4_Y.push_back(1.16);
    Vector4_X.push_back(101);   Vector4_Y.push_back(1.17);
    Vector4_X.push_back(102);   Vector4_Y.push_back(1.19);
    Vector4_X.push_back(103);   Vector4_Y.push_back(1.2);
    Vector4_X.push_back(104);   Vector4_Y.push_back(1.21);
    Vector4_X.push_back(105);   Vector4_Y.push_back(1.22);
    Vector4_X.push_back(106);   Vector4_Y.push_back(1.24);
    Vector4_X.push_back(107);   Vector4_Y.push_back(1.25);
    Vector4_X.push_back(108);   Vector4_Y.push_back(1.26);
    Vector4_X.push_back(109);   Vector4_Y.push_back(1.27);
    Vector4_X.push_back(110);   Vector4_Y.push_back(1.28);
    Vector4_X.push_back(111);   Vector4_Y.push_back(1.29);
    Vector4_X.push_back(112);   Vector4_Y.push_back(1.3);
    Vector4_X.push_back(113);   Vector4_Y.push_back(1.31);
    Vector4_X.push_back(114);   Vector4_Y.push_back(1.32);
    Vector4_X.push_back(115);   Vector4_Y.push_back(1.33);
    Vector4_X.push_back(116);   Vector4_Y.push_back(1.34);
    Vector4_X.push_back(117);   Vector4_Y.push_back(1.34);
    Vector4_X.push_back(118);   Vector4_Y.push_back(1.35);
    Vector4_X.push_back(119);   Vector4_Y.push_back(1.36);
    Vector4_X.push_back(120);   Vector4_Y.push_back(1.37);
    Vector4_X.push_back(121);   Vector4_Y.push_back(1.37);
    Vector4_X.push_back(122);   Vector4_Y.push_back(1.38);
    Vector4_X.push_back(123);   Vector4_Y.push_back(1.38);
    Vector4_X.push_back(124);   Vector4_Y.push_back(1.39);
    Vector4_X.push_back(125);   Vector4_Y.push_back(1.39);
    Vector4_X.push_back(126);   Vector4_Y.push_back(1.4);
    Vector4_X.push_back(127);   Vector4_Y.push_back(1.4);
    Vector4_X.push_back(128);   Vector4_Y.push_back(1.4);
    Vector4_X.push_back(129);   Vector4_Y.push_back(1.41);
    Vector4_X.push_back(130);   Vector4_Y.push_back(1.41);
    Vector4_X.push_back(131);   Vector4_Y.push_back(1.41);
    Vector4_X.push_back(132);   Vector4_Y.push_back(1.41);
    Vector4_X.push_back(133);   Vector4_Y.push_back(1.41);
    Vector4_X.push_back(134);   Vector4_Y.push_back(1.41);
    Vector4_X.push_back(135);   Vector4_Y.push_back(1.41);
    Vector4_X.push_back(136);   Vector4_Y.push_back(1.41);
    Vector4_X.push_back(137);   Vector4_Y.push_back(1.41);
    Vector4_X.push_back(138);   Vector4_Y.push_back(1.41);
    Vector4_X.push_back(139);   Vector4_Y.push_back(1.41);
    Vector4_X.push_back(140);   Vector4_Y.push_back(1.41);
    Vector4_X.push_back(141);   Vector4_Y.push_back(1.41);
    Vector4_X.push_back(142);   Vector4_Y.push_back(1.4);
    Vector4_X.push_back(143);   Vector4_Y.push_back(1.4);
    Vector4_X.push_back(144);   Vector4_Y.push_back(1.4);
    Vector4_X.push_back(145);   Vector4_Y.push_back(1.39);
    Vector4_X.push_back(146);   Vector4_Y.push_back(1.39);
    Vector4_X.push_back(147);   Vector4_Y.push_back(1.38);
    Vector4_X.push_back(148);   Vector4_Y.push_back(1.38);
    Vector4_X.push_back(149);   Vector4_Y.push_back(1.37);
    Vector4_X.push_back(150);   Vector4_Y.push_back(1.37);
    Vector4_X.push_back(151);   Vector4_Y.push_back(1.36);
    Vector4_X.push_back(152);   Vector4_Y.push_back(1.35);
    Vector4_X.push_back(153);   Vector4_Y.push_back(1.34);
    Vector4_X.push_back(154);   Vector4_Y.push_back(1.34);
    Vector4_X.push_back(155);   Vector4_Y.push_back(1.33);
    Vector4_X.push_back(156);   Vector4_Y.push_back(1.32);
    Vector4_X.push_back(157);   Vector4_Y.push_back(1.31);
    Vector4_X.push_back(158);   Vector4_Y.push_back(1.3);
    Vector4_X.push_back(159);   Vector4_Y.push_back(1.29);
    Vector4_X.push_back(160);   Vector4_Y.push_back(1.28);
    Vector4_X.push_back(161);   Vector4_Y.push_back(1.27);
    Vector4_X.push_back(162);   Vector4_Y.push_back(1.26);
    Vector4_X.push_back(163);   Vector4_Y.push_back(1.25);
    Vector4_X.push_back(164);   Vector4_Y.push_back(1.24);
    Vector4_X.push_back(165);   Vector4_Y.push_back(1.22);
    Vector4_X.push_back(166);   Vector4_Y.push_back(1.21);
    Vector4_X.push_back(167);   Vector4_Y.push_back(1.2);
    Vector4_X.push_back(168);   Vector4_Y.push_back(1.19);
    Vector4_X.push_back(169);   Vector4_Y.push_back(1.17);
    Vector4_X.push_back(170);   Vector4_Y.push_back(1.16);
    Vector4_X.push_back(171);   Vector4_Y.push_back(1.14);
    Vector4_X.push_back(172);   Vector4_Y.push_back(1.13);
    Vector4_X.push_back(173);   Vector4_Y.push_back(1.11);
    Vector4_X.push_back(174);   Vector4_Y.push_back(1.1);
    Vector4_X.push_back(175);   Vector4_Y.push_back(1.08);
    Vector4_X.push_back(176);   Vector4_Y.push_back(1.07);
    Vector4_X.push_back(177);   Vector4_Y.push_back(1.05);
    Vector4_X.push_back(178);   Vector4_Y.push_back(1.03);
    Vector4_X.push_back(179);   Vector4_Y.push_back(1.02);
    Vector4_X.push_back(180);   Vector4_Y.push_back(1);
    Vector4_X.push_back(181);   Vector4_Y.push_back(0.98);
    Vector4_X.push_back(182);   Vector4_Y.push_back(0.96);
    Vector4_X.push_back(183);   Vector4_Y.push_back(0.95);
    Vector4_X.push_back(184);   Vector4_Y.push_back(0.93);
    Vector4_X.push_back(185);   Vector4_Y.push_back(0.91);
    Vector4_X.push_back(186);   Vector4_Y.push_back(0.89);
    Vector4_X.push_back(187);   Vector4_Y.push_back(0.87);
    Vector4_X.push_back(188);   Vector4_Y.push_back(0.85);
    Vector4_X.push_back(189);   Vector4_Y.push_back(0.83);
    Vector4_X.push_back(190);   Vector4_Y.push_back(0.81);
    Vector4_X.push_back(191);   Vector4_Y.push_back(0.79);
    Vector4_X.push_back(192);   Vector4_Y.push_back(0.77);
    Vector4_X.push_back(193);   Vector4_Y.push_back(0.75);
    Vector4_X.push_back(194);   Vector4_Y.push_back(0.73);
    Vector4_X.push_back(195);   Vector4_Y.push_back(0.71);
    Vector4_X.push_back(196);   Vector4_Y.push_back(0.69);
    Vector4_X.push_back(197);   Vector4_Y.push_back(0.66);
    Vector4_X.push_back(198);   Vector4_Y.push_back(0.64);
    Vector4_X.push_back(199);   Vector4_Y.push_back(0.62);
    Vector4_X.push_back(200);   Vector4_Y.push_back(0.6);
    Vector4_X.push_back(201);   Vector4_Y.push_back(0.58);
    Vector4_X.push_back(202);   Vector4_Y.push_back(0.55);
    Vector4_X.push_back(203);   Vector4_Y.push_back(0.53);
    Vector4_X.push_back(204);   Vector4_Y.push_back(0.51);
    Vector4_X.push_back(205);   Vector4_Y.push_back(0.48);
    Vector4_X.push_back(206);   Vector4_Y.push_back(0.46);
    Vector4_X.push_back(207);   Vector4_Y.push_back(0.44);
    Vector4_X.push_back(208);   Vector4_Y.push_back(0.41);
    Vector4_X.push_back(209);   Vector4_Y.push_back(0.39);
    Vector4_X.push_back(210);   Vector4_Y.push_back(0.37);
    Vector4_X.push_back(211);   Vector4_Y.push_back(0.34);
    Vector4_X.push_back(212);   Vector4_Y.push_back(0.32);
    Vector4_X.push_back(213);   Vector4_Y.push_back(0.29);
    Vector4_X.push_back(214);   Vector4_Y.push_back(0.27);
    Vector4_X.push_back(215);   Vector4_Y.push_back(0.25);
    Vector4_X.push_back(216);   Vector4_Y.push_back(0.22);
    Vector4_X.push_back(217);   Vector4_Y.push_back(0.2);
    Vector4_X.push_back(218);   Vector4_Y.push_back(0.17);
    Vector4_X.push_back(219);   Vector4_Y.push_back(0.15);
    Vector4_X.push_back(220);   Vector4_Y.push_back(0.12);
    Vector4_X.push_back(221);   Vector4_Y.push_back(0.1);
    Vector4_X.push_back(222);   Vector4_Y.push_back(0.07);
    Vector4_X.push_back(223);   Vector4_Y.push_back(0.05);
    Vector4_X.push_back(224);   Vector4_Y.push_back(0.02);
    Vector4_X.push_back(225);   Vector4_Y.push_back(0);
    Vector4_X.push_back(226);   Vector4_Y.push_back(-0.02);
    Vector4_X.push_back(227);   Vector4_Y.push_back(-0.05);
    Vector4_X.push_back(228);   Vector4_Y.push_back(-0.07);
    Vector4_X.push_back(229);   Vector4_Y.push_back(-0.1);
    Vector4_X.push_back(230);   Vector4_Y.push_back(-0.12);
    Vector4_X.push_back(231);   Vector4_Y.push_back(-0.15);
    Vector4_X.push_back(232);   Vector4_Y.push_back(-0.17);
    Vector4_X.push_back(233);   Vector4_Y.push_back(-0.2);
    Vector4_X.push_back(234);   Vector4_Y.push_back(-0.22);
    Vector4_X.push_back(235);   Vector4_Y.push_back(-0.25);
    Vector4_X.push_back(236);   Vector4_Y.push_back(-0.27);
    Vector4_X.push_back(237);   Vector4_Y.push_back(-0.29);
    Vector4_X.push_back(238);   Vector4_Y.push_back(-0.32);
    Vector4_X.push_back(239);   Vector4_Y.push_back(-0.34);
    Vector4_X.push_back(240);   Vector4_Y.push_back(-0.37);
    Vector4_X.push_back(241);   Vector4_Y.push_back(-0.39);
    Vector4_X.push_back(242);   Vector4_Y.push_back(-0.41);
    Vector4_X.push_back(243);   Vector4_Y.push_back(-0.44);
    Vector4_X.push_back(244);   Vector4_Y.push_back(-0.46);
    Vector4_X.push_back(245);   Vector4_Y.push_back(-0.48);
    Vector4_X.push_back(246);   Vector4_Y.push_back(-0.51);
    Vector4_X.push_back(247);   Vector4_Y.push_back(-0.53);
    Vector4_X.push_back(248);   Vector4_Y.push_back(-0.55);
    Vector4_X.push_back(249);   Vector4_Y.push_back(-0.58);
    Vector4_X.push_back(250);   Vector4_Y.push_back(-0.6);
    Vector4_X.push_back(251);   Vector4_Y.push_back(-0.62);
    Vector4_X.push_back(252);   Vector4_Y.push_back(-0.64);
    Vector4_X.push_back(253);   Vector4_Y.push_back(-0.66);
    Vector4_X.push_back(254);   Vector4_Y.push_back(-0.69);
    Vector4_X.push_back(255);   Vector4_Y.push_back(-0.71);
    Vector4_X.push_back(256);   Vector4_Y.push_back(-0.73);
    Vector4_X.push_back(257);   Vector4_Y.push_back(-0.75);
    Vector4_X.push_back(258);   Vector4_Y.push_back(-0.77);
    Vector4_X.push_back(259);   Vector4_Y.push_back(-0.79);
    Vector4_X.push_back(260);   Vector4_Y.push_back(-0.81);
    Vector4_X.push_back(261);   Vector4_Y.push_back(-0.83);
    Vector4_X.push_back(262);   Vector4_Y.push_back(-0.85);
    Vector4_X.push_back(263);   Vector4_Y.push_back(-0.87);
    Vector4_X.push_back(264);   Vector4_Y.push_back(-0.89);
    Vector4_X.push_back(265);   Vector4_Y.push_back(-0.91);
    Vector4_X.push_back(266);   Vector4_Y.push_back(-0.93);
    Vector4_X.push_back(267);   Vector4_Y.push_back(-0.95);
    Vector4_X.push_back(268);   Vector4_Y.push_back(-0.96);
    Vector4_X.push_back(269);   Vector4_Y.push_back(-0.98);
    Vector4_X.push_back(270);   Vector4_Y.push_back(-1);
    Vector4_X.push_back(271);   Vector4_Y.push_back(-1.02);
    Vector4_X.push_back(272);   Vector4_Y.push_back(-1.03);
    Vector4_X.push_back(273);   Vector4_Y.push_back(-1.05);
    Vector4_X.push_back(274);   Vector4_Y.push_back(-1.07);
    Vector4_X.push_back(275);   Vector4_Y.push_back(-1.08);
    Vector4_X.push_back(276);   Vector4_Y.push_back(-1.1);
    Vector4_X.push_back(277);   Vector4_Y.push_back(-1.11);
    Vector4_X.push_back(278);   Vector4_Y.push_back(-1.13);
    Vector4_X.push_back(279);   Vector4_Y.push_back(-1.14);
    Vector4_X.push_back(280);   Vector4_Y.push_back(-1.16);
    Vector4_X.push_back(281);   Vector4_Y.push_back(-1.17);
    Vector4_X.push_back(282);   Vector4_Y.push_back(-1.19);
    Vector4_X.push_back(283);   Vector4_Y.push_back(-1.2);
    Vector4_X.push_back(284);   Vector4_Y.push_back(-1.21);
    Vector4_X.push_back(285);   Vector4_Y.push_back(-1.22);
    Vector4_X.push_back(286);   Vector4_Y.push_back(-1.24);
    Vector4_X.push_back(287);   Vector4_Y.push_back(-1.25);
    Vector4_X.push_back(288);   Vector4_Y.push_back(-1.26);
    Vector4_X.push_back(289);   Vector4_Y.push_back(-1.27);
    Vector4_X.push_back(290);   Vector4_Y.push_back(-1.28);
    Vector4_X.push_back(291);   Vector4_Y.push_back(-1.29);
    Vector4_X.push_back(292);   Vector4_Y.push_back(-1.3);
    Vector4_X.push_back(293);   Vector4_Y.push_back(-1.31);
    Vector4_X.push_back(294);   Vector4_Y.push_back(-1.32);
    Vector4_X.push_back(295);   Vector4_Y.push_back(-1.33);
    Vector4_X.push_back(296);   Vector4_Y.push_back(-1.34);
    Vector4_X.push_back(297);   Vector4_Y.push_back(-1.34);
    Vector4_X.push_back(298);   Vector4_Y.push_back(-1.35);
    Vector4_X.push_back(299);   Vector4_Y.push_back(-1.36);
    Vector4_X.push_back(300);   Vector4_Y.push_back(-1.37);
    Vector4_X.push_back(301);   Vector4_Y.push_back(-1.37);
    Vector4_X.push_back(302);   Vector4_Y.push_back(-1.38);
    Vector4_X.push_back(303);   Vector4_Y.push_back(-1.38);
    Vector4_X.push_back(304);   Vector4_Y.push_back(-1.39);
    Vector4_X.push_back(305);   Vector4_Y.push_back(-1.39);
    Vector4_X.push_back(306);   Vector4_Y.push_back(-1.4);
    Vector4_X.push_back(307);   Vector4_Y.push_back(-1.4);
    Vector4_X.push_back(308);   Vector4_Y.push_back(-1.4);
    Vector4_X.push_back(309);   Vector4_Y.push_back(-1.41);
    Vector4_X.push_back(310);   Vector4_Y.push_back(-1.41);
    Vector4_X.push_back(311);   Vector4_Y.push_back(-1.41);
    Vector4_X.push_back(312);   Vector4_Y.push_back(-1.41);
    Vector4_X.push_back(313);   Vector4_Y.push_back(-1.41);
    Vector4_X.push_back(314);   Vector4_Y.push_back(-1.41);
    Vector4_X.push_back(315);   Vector4_Y.push_back(-1.41);
    Vector4_X.push_back(316);   Vector4_Y.push_back(-1.41);
    Vector4_X.push_back(317);   Vector4_Y.push_back(-1.41);
    Vector4_X.push_back(318);   Vector4_Y.push_back(-1.41);
    Vector4_X.push_back(319);   Vector4_Y.push_back(-1.41);
    Vector4_X.push_back(320);   Vector4_Y.push_back(-1.41);
    Vector4_X.push_back(321);   Vector4_Y.push_back(-1.41);
    Vector4_X.push_back(322);   Vector4_Y.push_back(-1.4);
    Vector4_X.push_back(323);   Vector4_Y.push_back(-1.4);
    Vector4_X.push_back(324);   Vector4_Y.push_back(-1.4);
    Vector4_X.push_back(325);   Vector4_Y.push_back(-1.39);
    Vector4_X.push_back(326);   Vector4_Y.push_back(-1.39);
    Vector4_X.push_back(327);   Vector4_Y.push_back(-1.38);
    Vector4_X.push_back(328);   Vector4_Y.push_back(-1.38);
    Vector4_X.push_back(329);   Vector4_Y.push_back(-1.37);
    Vector4_X.push_back(330);   Vector4_Y.push_back(-1.37);
    Vector4_X.push_back(331);   Vector4_Y.push_back(-1.36);
    Vector4_X.push_back(332);   Vector4_Y.push_back(-1.35);
    Vector4_X.push_back(333);   Vector4_Y.push_back(-1.34);
    Vector4_X.push_back(334);   Vector4_Y.push_back(-1.34);
    Vector4_X.push_back(335);   Vector4_Y.push_back(-1.33);
    Vector4_X.push_back(336);   Vector4_Y.push_back(-1.32);
    Vector4_X.push_back(337);   Vector4_Y.push_back(-1.31);
    Vector4_X.push_back(338);   Vector4_Y.push_back(-1.3);
    Vector4_X.push_back(339);   Vector4_Y.push_back(-1.29);
    Vector4_X.push_back(340);   Vector4_Y.push_back(-1.28);
    Vector4_X.push_back(341);   Vector4_Y.push_back(-1.27);
    Vector4_X.push_back(342);   Vector4_Y.push_back(-1.26);
    Vector4_X.push_back(343);   Vector4_Y.push_back(-1.25);
    Vector4_X.push_back(344);   Vector4_Y.push_back(-1.24);
    Vector4_X.push_back(345);   Vector4_Y.push_back(-1.22);
    Vector4_X.push_back(346);   Vector4_Y.push_back(-1.21);
    Vector4_X.push_back(347);   Vector4_Y.push_back(-1.2);
    Vector4_X.push_back(348);   Vector4_Y.push_back(-1.19);
    Vector4_X.push_back(349);   Vector4_Y.push_back(-1.17);
    Vector4_X.push_back(350);   Vector4_Y.push_back(-1.16);
    Vector4_X.push_back(351);   Vector4_Y.push_back(-1.14);
    Vector4_X.push_back(352);   Vector4_Y.push_back(-1.13);
    Vector4_X.push_back(353);   Vector4_Y.push_back(-1.11);
    Vector4_X.push_back(354);   Vector4_Y.push_back(-1.1);
    Vector4_X.push_back(355);   Vector4_Y.push_back(-1.08);
    Vector4_X.push_back(356);   Vector4_Y.push_back(-1.07);
    Vector4_X.push_back(357);   Vector4_Y.push_back(-1.05);
    Vector4_X.push_back(358);   Vector4_Y.push_back(-1.03);
    Vector4_X.push_back(359);   Vector4_Y.push_back(-1.02);
    Vector4_X.push_back(360);   Vector4_Y.push_back(-1);
    Vector4_X.push_back(360);   Vector4_Y.push_back(-1);
    Vector4->SetData(Vector4_X, Vector4_Y);
    Vector4->SetContinuity(true);
    MathPlot1->AddLayer(Vector4);
    MathPlot1->UpdateAll();
    MathPlot1->Fit();
    MenuBar1 = new wxMenuBar();
    Menu1 = new wxMenu();
    MenuItem1 = new wxMenuItem(Menu1, idMenuQuit, _("Quit\tAlt-F4"), _("Quit the application"), wxITEM_NORMAL);
    Menu1->Append(MenuItem1);
    MenuBar1->Append(Menu1, _("&File"));
    Menu2 = new wxMenu();
    MenuItem2 = new wxMenuItem(Menu2, idMenuAbout, _("About\tF1"), _("Show info about this application"), wxITEM_NORMAL);
    Menu2->Append(MenuItem2);
    MenuBar1->Append(Menu2, _("Help"));
    SetMenuBar(MenuBar1);

    Connect(idMenuQuit,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&TestPlotFrame::OnQuit);
    Connect(idMenuAbout,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&TestPlotFrame::OnAbout);
    //*)

    MathPlot1->Fit();
}

TestPlotFrame::~TestPlotFrame()
{
    //(*Destroy(TestPlotFrame)
    //*)
}

void TestPlotFrame::OnQuit(wxCommandEvent& event)
{
    Close();
}

void TestPlotFrame::OnAbout(wxCommandEvent& event)
{
    wxString msg = wxbuildinfo(long_f);
    wxMessageBox(msg, _("Welcome to..."));
}
